//迷路生成クラス
function makeLaby(scene,scene2D,x,y,texs){
	//初期化
	this.clear = function(){
		for(var i=0; i<this.lengX; i++){
			this.grid[i] = [];
			for(var j=0; j<this.lengY; j++){
				this.grid[i][j] = 0;
				if(i == 0 || i == this.lengX - 1 || j == 0 || j == this.lengY - 1) this.grid[i][j] = 1;
			}
		}
	}
	//迷路生成
	this.set = function(){
		var sum = ((this.lengX - 1)/ 2 - 1)  * ((this.lengY  - 1) / 2 - 1);
		var minX = 1; var minY = 1;
		var count = 0;
		while(1){
			var can = 1;
			while(1){
				var px = rand(this.lengX); var py = rand(this.lengY);
				if(this.grid[px][py] == 1 && (px % 2) == 0 && (py % 2) == 0 && (px + py) > 0) break;
			}
			while(can){
				var dir = rand(4);
				var mx = 0; var my = 0; var move = 2;
				switch(dir){
					case 0: mx = move; break;
					case 1: mx = -move; break;
					case 2: my = move; break;
					case 3: my = -move; break;
				}
				var nx = px + mx; var ny = py + my;
				if(nx >= 0 && ny >= 0 && nx <= this.lengX && ny <= this.lengY){
					if(this.grid[nx][ny] == 0 && can){
						for(var i=1; i<3; i++){
							switch(dir){
								case 0: this.grid[px + i][py] = 1; break;
								case 1: this.grid[px - i][py] = 1; break;
								case 2: this.grid[px][py + i] = 1; break;
								case 3: this.grid[px][py - i] = 1; break;
							}
						}
						count++;
						px = px + mx; py = py + my;
					}else{ can = 0; }
				}
			}
			if(count == sum) break;
		}
	}
	//全てのブロックをフェードアウトさせる
	this.allBlockFadeOut = function(func){
		//ブロック
		for(var i=0; i<this.lengX; i++){
			for(var j=0; j<this.lengY; j++){
				if(this.grid[i][j]){
					var sp = this.SPs[i][j];
					sp.fadeCount = 0;
					sp.clearEventListener("enterframe");
					sp.addEventListener("enterframe",function(){
						this.fadeCount++;
						var num = 0.1
						this.scaleX -= num; this.scaleY -= num; this.scaleZ -= num;
						if(this.fadeCount == 9){
							this.clearEventListener("enterframe");
							this.parentNode.removeChild(this);
							func();
						}
					});
				}
			}
		}
		//オブジェクト
		for(var i=0; i<this.objsAll; i++){
			scene3D.removeChild(this.objStr[i].sp);
		}
	}
	//全描画
	this.makeSP = function(){
		for(var i=0; i<this.lengX; i++){
			this.SPs[i] = [];
			for(var j=0; j<this.lengY; j++){
				if(this.grid[i][j]){
					//外形生成
					function makeSurf(w,h,tex){
						var lengX = 2;
						var lengY = 2;
						var sf = new Surface(w,h);
						var ctx = sf.context;
						ctx.lineWidth = 2;
						ctx.shadowBlur = 6;
						ctx.fillStyle = makeRainbowRand();
						ctx.fillRect(0,0,sf.width,sf.height);
						var sw = 0;
						for(var i=0; i<lengX; i++){
							var setx = w / lengX * i;
							for(var j= sw; j<lengY; j++){
								var sety = h / lengY * j;
								var gra = ctx.createLinearGradient(setx,sety,setx + w,sety + h);
								ctx.shadowColor = "rgba(255,255,255,1)";
								gra.addColorStop(0,makeRainbowRand());
								gra.addColorStop(1,"rgba(255,255,255,1)");
								ctx.fillStyle = gra;
								ctx.fillRect(setx,sety,w / lengX,h / lengY);
								ctx.strokeStyle = "rgba(0,0,0,0.5)";
								ctx.strokeRect(setx,sety,w / lengX,h / lengY);
							}
						}
						var img = game.assets[tex];
						var x = (sf.width - img.width) / 2;
						var y = (sf.height - img.height) / 2;
						sf.draw(img,0,0,img.width,img.height,x,y,img.width,img.height);
						sf._element.src = Math.random();
						return sf;
					}
					//ランダム回転
					function rotate(node){
						var ang = 90 * Math.PI / 180;
						node.rotatePitch(rand(4) * ang);
						node.rotateRoll(rand(4) * ang);
						node.rotateYaw(rand(4) * ang);
					}
					//壁生成
					this.SPs[i][j] = new Box(this.size,this.size,this.size);
					var sp = this.SPs[i][j];
					sp.bsColor = [1,1,1,1];
					sp.mesh.setBaseColor(sp.bsColor);
					sp.mesh.texture.ambient = [0.8,0.8,0.8,0.5];
					sp.mesh.texture.src = makeSurf(this.size,this.size,this.texs[rand(this.texs.length)]);
					this.scene.addChild(sp);
					rotate(this.SPs[i][j]);
				}else{
					this.SPs[i][j] = new Sprite3D();
				}
				//共通処理
				this.SPs[i][j].size = this.size;
				this.SPs[i][j].x = i * this.size * 2;
				this.SPs[i][j].y = this.size;
				this.SPs[i][j].z = j * this.size * 2;
				this.SPs[i][j].opacity = 1;
			}
		}
	}
	//描画範囲限定
	this.setSpriteDist = function(node,dist){
		var cls = this;
		node.addEventListener("enterframe",function(){
			//壁
			for(var i=0; i<cls.lengX; i++){
				for(var j=0; j<cls.lengY; j++){
					cls.setSpriteOpacity(cls.SPs[i][j]);
				}
			}
			//アイテム
			for(var i=0; i<cls.items.length; i++){
				cls.setSpriteOpacity(cls.items[i].sp);
			}
			//オブジェクト
			for(var i=0; i<cls.objStr.length; i++){
				cls.setSpriteOpacity(cls.objStr[i].sp);
			}
		});
		//判定処理と実行
		this.setSpriteOpacity = function(sp){
			if(sp != null){
				var x = node.x - sp.x; var y = node.z - sp.z;
				var distance = Math.sqrt(x * x + y * y);
				if(distance >= dist){
					cls.scene.removeChild(sp);
					sp.opacity = 0;
				}else if(sp.opacity == 0){
					cls.scene.addChild(sp);
					sp.opacity = 1;
				}
			}
		}
	}
	//ランダム位置セット
	this.setRandP = function(){
		while(1){
			this.randX = rand(this.lengX);
			this.randY = rand(this.lengY);
			if(this.grid[this.randX][this.randY] == 0) break;
		}
	}
	//オブジェクト位置セット
	this.setPosition = function(){
		//スタートとゴールが同一ならリセット
		while(1){
			this.setStartP();	//スタート
			this.setGoalP();	//ゴール
			if(this.startX != this.goalX || this.startY != this.goalY) break;
		}
	}
	//ワープオブジェクトワープ地点セット
	this.setWarpP = function(obj){
		while(1){
			this.setRandP();
			obj.warpI = this.randX;
			obj.warpJ = this.randY;
			obj.warpX = obj.warpI * this.size * 2;
			obj.warpY = obj.warpJ * this.size * 2;
			if(this.objs[obj.warpI][obj.warpJ].id == -1) break;			//何もない場所に設置
		}
	}
	//千里眼セット
	this.setVoyance = function(set){
		if(set){
			this.voyance = 1;
		}else{
			this.voyance = 0;
			//マップ更新
			this.refMap();
		}
	}
	//スタート位置セット
	this.setStartP = function(){
		this.setRandP();
		this.startI = this.randX;
		this.startJ = this.randY;
		this.startX = this.startI * this.size * 2;
		this.startY = this.startJ * this.size * 2;
	}
	//ゴール位置セット
	this.setGoalP = function(){
		this.setRandP();
		this.goalI = this.randX;
		this.goalJ = this.randY;
		this.goalX = this.setOneGridRand(this.goalI);
		this.goalY = this.setOneGridRand(this.goalJ);
	}
	//指定マスのどこかのランダムな値を返す
	this.setOneGridRand = function(num){
		var white = this.size / 20;
		var range = this.size - white;
		return num * this.size * 2 + rand(range * 2,-range);
	}
	//アイテムタッチノードセット
	this.setItemTouchNode = function(node){
		this.touchNode = node;
	}
	//アイテムランダムセット
	this.setItemRand = function(){
		this.randEnt = new Entity();
		this.randEnt.inter = 600;
		this.randEnt.count = this.randEnt.inter;
		this.scene2D.addChild(this.randEnt);
		//初期描画
		this.setItemRand_set();
		//一定時間ごとに描画
		var cls = this;
		this.randEnt.addEventListener("enterframe",function(){
			this.count++;
			if(this.count >= this.inter){
				this.count = 0;
				cls.setVoyance();				//千里眼効力無し
				cls.setItemRandAnime();
				cls.setItemRand_del();
				cls.setItemRand_set();
			}
		});
	}
	//アイテムdel
	this.setItemRand_del = function(){
		for(var i=0; i<this.setItemAll; i++){
			this.items[i].del();
		}
	}
	//アイテムセットアニメ
	this.setItemRandAnime = function(){
		//Flash
		makeFlash(scene2D,"rgba(255,255,255,1)",0.5,10);
		//音声
		mySubSE.play(2);
		var sp = new myText(this.scene2D,"Refresh!!","myfont",80,null,null);
		sp.sp.x = 10;
		sp.sp.y = screenHeight / 1.8;
		sp.sp.opacity = 0;
		sp.sp.scale(0,0);
		sp.colors = ["rgba(0,255,0,1)","rgba(0,128,0,1)","rgba(255,255,255,1)"];
		var time = 5;
		sp.sp.tl.
		scaleTo(1.5,time,eas).and().
		fadeTo(1,time,eas).
		scaleTo(1,time,eas).
		delay(time * 2).
		fadeTo(0,time,eas).
		then(function(){
			this.parentNode.removeChild(this);
			delete sp;
		});
		sp.setUnderCtx("rgba(0,255,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)");
		sp.set();
	}
	//アイテムセット
	this.setItemRand_set = function(){
		for(var i=0; i<this.setItemAll; i++){
			this.setRandP();
			var x = this.setOneGridRand(this.randX);
			var y = this.setOneGridRand(this.randY);
			this.items[i] = new setItem(this.scene,this.scene2D,this.itemTypes,null,x,y);			//アイテムクラスセット
			this.items[i].i = this.randX;
			this.items[i].j = this.randY;
			this.items[i].onX = x;
			this.items[i].onY = y;
			this.items[i].setID(rand(this.items[i].types.length));									//アイテムIDのセット(ランダム)
			this.items[i].setSP();																	//スプライトセット
			this.items[i].setEnter(this.touchNode);													//指定ノードへタッチ判定付与
		}
	}
	//固定オブジェクトタッチノードセット
	this.setObjTouchNode = function(node){
		this.objsNode = node;
	}
	//固定オブジェクトセット
	this.setObj = function(id,x,y){
		var num = this.objStr.length;
		this.objStr.push(new setObject(this.scene,this.scene2D,id,x,y,this.objsNode));
		var obj = this.objStr[num];
		obj.setInfo(this.objTypes);
		obj.setSP();
		obj.setEnter();
		obj.setTouch();
	}
	//オブジェクト設置配列初期化
	this.objsInfosClear = function(){
		//全マス分の情報初期化
		for(var i=0; i<this.lengX; i++){
			this.objs[i] = [];
			for(var j=0; j<this.lengY; j++){
				this.objs[i][j] = new set();
			}
		}
		function set(){
			this.id = -1;						//初期値-1
			this.obj = null;
		}
	}
	//全オブジェクトセット
	this.setObjAll = function(){
		var warpCount = 0;
		for(var i=0; i<this.objsAll; i++){
			var id = null;
			while(1){
				this.setRandP();
				if(this.objs[this.randX][this.randY].id == -1){
					id = rand(this.objTypes.length);
					this.objs[this.randX][this.randY].id = id;
					break;
				}
			}
			var oi = this.randX;
			var oj = this.randY;
			var x = oi * this.size * 2;
			var y = oj * this.size * 2;
			this.setObj(id,x,y);
			//グリッド情報とのジョイント
			this.objs[oi][oj].obj =  this.objStr[i];
			//ワープなら要素数の記憶
			var obj = this.objs[oi][oj].obj;
			if(obj.types[obj.id].type == "warp"){
				warpCount++;
				obj.wNum = warpCount;
			}
		}
		//当たり判定総確認セット
		this.setObjTouching();
	}
	//オブジェクトの当たり判定の総確認
	this.setObjTouching = function(){
		this.touchSP = new myText(this.scene2D,"使えよ郷太！…PUSH「Z」","myfont",46,null,null);
		var touch = this.touchSP;
		touch.sp.opacity = 0;
		touch.sp.touching = 0;
		touch.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
		touch.set();
		var cls = this;
		touch.sp.addEventListener("enterframe",function(){
			this.opacity = 0;
			for(var i=0; i<cls.objsAll; i++){
				var obj = cls.objStr[i];
				if(obj.touching){
					this.opacity = 1;
					if(obj.sp.canTouch && game.input.z){
						obj.clickEV();
						for(var j=0; j<cls.objsAll; j++){
							cls.objStr[j].touching = 0;
							cls.objStr[j].sp.canTouch = 0;
						}
					}
					break;
				}
			}

		});
	}
	//当たり判定セット
	this.setTouch = function(node){
		var cls = this;
		node.addEventListener("enterframe",function(){
			cls.touching = 0;
			for(var i=0; i<cls.lengX; i++){
				for(var j=0; j<cls.lengY; j++){
					if(cls.grid[i][j] && touch(cls.SPs[i][j])){
						cls.touching = 1;							//当たり判定
						cls.touchingDir = setDir(cls.SPs[i][j]);	//当たった方向
						//タッチ判定用スプライトと同値に
						var dir = cls.touchingDir;
						if(dir != 2 && dir != 3) node.x = node.touchSP.x;
						if(dir != 1 && dir != 4) node.z = node.touchSP.z;
						return 1;									//終了
					}
				}
			}
			//何も無い場合タッチ判定用スプライトと同値に
			node.x = node.touchSP.x;
			node.z = node.touchSP.z;
		});
		//当たり判定
		function touch(my){
			var px = node.touchSP.x; var py = node.touchSP.z;
			var white = my.size / 5; var add = my.size + white;
			var sx = my.x - add; var ex = my.x + add;
			var sy = my.z - add; var ey = my.z + add;
			if(px >= sx && px <= ex && py >= sy && py <= ey) return 1;
			return 0;
		}
		//方向判定
		function setDir(my){
			var px = my.x - node.touchSP.x;
			var pz = my.z - node.touchSP.z;
			var num = 0;
			if(Math.abs(px) > Math.abs(pz)){
				if(px >= 0)	{ num = 3; }
				else		{ num = 2; }
			}else{	
				if(pz >= 0)	{ num = 4; }
				else		{ num = 1; }
			}
			return num;
		}
	}
	//地図生成
	this.makeMap = function(x,y,size){
		//描画許可マス情報格納
		this.clearMap();					//初期化
		//描画
		this.mapSP = new Sprite(size * this.lengX,size * this.lengY);
		this.mapSP.size = size;
		this.sf  = new Surface(this.mapSP.width,this.mapSP.height);
		this.mapSP.image = this.makeMapSurf();
		this.scene2D.addChild(this.mapSP);
	}
	//地図許可情報初期化
	this.clearMap = function(){
		this.mapShows = [];
		for(var i=0; i<this.lengX; i++){
			this.mapShows[i] = [];
			for(var j=0; j<this.lengY; j++){
				this.mapShows[i][j] = 0;
			}
		}
	}
	//地図更新
	this.refMap = function(){
		this.mapSP.image = this.makeMapSurf();
	}
	//地図surf生成
	this.makeMapSurf = function(){
		var sf = this.sf;
		var ctx = sf.context;
		var size = this.mapSP.size;
		ctx.clearRect(0,0,sf.width,sf.height);
		ctx.beginPath();
		//汎用ループ
		function loop(cls,func){
			for(var i=0; i<cls.lengX; i++){
				for(var j=0; j<cls.lengY; j++){
					if(cls.grid[i][j] == 0 && cls.mapShows[i][j]) func(cls,i,j);
				}
			}
		}
		//道
		loop(this,function(cls,i,j){
			ctx.beginPath();
			ctx.fillStyle = "rgba(0,0,255,0.5)";
			ctx.fillRect(i * size,j * size,size,size);
		});
		//オブジェクト
		loop(this,function(cls,i,j){
			//固定オブジェクトが設置されている場合は色を追加
			if(cls.objs[i][j].id != -1){
				var obj = cls.objs[i][j].obj;
				var color = obj.types[obj.id].iconColor;
				var white = size / 6;
				ctx.beginPath();
				ctx.fillStyle = color;
				ctx.fillRect(white + i * size,white + j * size,size - white * 2,size - white * 2);
				//固定オブジェクトがワープの場合の特殊処理
				if(obj.types[obj.id].type == "warp"){
					var txt = ""+size * 1.5+"";
					ctx.beginPath();
					ctx.font = ""+txt+"px myfont";
					ctx.fillStyle = "rgba(255,255,255,1)";
					ctx.fillText(obj.wNum,i * size + white,j * size + white * 2);
					//ワープ先
					ctx.beginPath();
					ctx.fillStyle = color;
					ctx.arc(size / 2 + obj.warpI * size,size / 2 + obj.warpJ * size,size / 2 - white,0,360,false);
					ctx.fill();
					ctx.fillStyle = "rgba(255,0,255,1)";
					ctx.fillText(obj.wNum,obj.warpI * size + white,obj.warpJ * size + white * 2);
				}
			}
		});
		//千里眼中はアイテムセット
		var str = this.items;
		if(this.voyance){
			var pSize = 4;
			for(var i=0; i<str.length; i++){
				var items = this.items;
				var itemI = items[i].i;
				var itemJ = items[i].j;
				var x = items[i].onX / this.bias - pSize / 2;
				var y = items[i].onY / this.bias - pSize / 2;
				ctx.fillStyle = items[i].info.color;
				ctx.fillRect(x,y,pSize,pSize);
			}
		}
		//返却
		return sf;
	}
	//fps表示
	this.showFPS = function(){
		var label = new Label();
		label.x = 600;
		label.y = 100;
		label.color = "rgba(255,0,0,1)";
		label.font = "30px myfont";
		label.count = 0;
		label.cMax = 60;
		label.sum = 0;
		label.onenterframe = function(){
			this.text = Math.floor(game.actualFps);
		}
		this.scene2D.addChild(label);
	}
	//ノード位置取得セット
	this.setNodePos = function(node,special){
		node.posSP = new Sprite(12,12);
		node.posSP.special = special;
		var spc = node.posSP.special;
		//surfセット
		var sf = new Surface(node.posSP.width,node.posSP.height);
		var ctx = sf.context;
		var white = 2;
		ctx.beginPath();
		if(spc != null){
			ctx.fillStyle = "rgba(255,200,200,1)";
			ctx.moveTo(white,0);
			ctx.lineTo(sf.width - white,0);
			ctx.lineTo(sf.width / 2,sf.height);
			ctx.lineTo(0,0);
			ctx.fill();
			ctx.stroke();
		}else{
			ctx.fillStyle = "rgba(255,0,0,1)";
			ctx.fillRect(white,white,sf.width - white * 2,sf.height - white * 2);
			ctx.strokeRect(white,white,sf.width - white * 2,sf.height - white * 2);
		}
		node.posSP.image = sf;
		//マップシーンにセット
		this.scene2D.addChild(node.posSP);
		//毎フレーム更新
		var cls = this;
		this.bias = this.mapSP.size * 1.21;
		node.posSP.i = null; node.posSP.j = null;
		this.mapSP.addEventListener("enterframe",function(){
			var sp = node.posSP;
			sp.x = node.x / cls.bias - sp.width / 2;
			sp.y = node.z / cls.bias - sp.height / 2;
			//回転する場合は回転
			if(spc) sp.rotation = -node.angleY;
			//中心取得
			sp.cx = sp.x + sp.width / 2;
			sp.cy = sp.y + sp.width / 2;
			for(var i=0; i<cls.lengX; i++){
				for(var j=0; j<cls.lengY; j++){
					if(touch(sp,cls.SPs[i][j])){
						sp.i = i; sp.j = j;
						if(cls.mapShows[i][j] == 0){
							if(spc != null) cls.mapShows[i][j] = 1;				//マップ更新
							if(!cls.voyance) cls.refMap();						//マップ更新描画
						}
					}
				}
			}
			//千里眼時は常に更新
			if(cls.voyance) cls.refMap();
			//スプライト表示確認
			if(sp.i != null && sp.j != null){
				if(cls.mapShows[sp.i][sp.j]){
					sp.opacity = 1;
				}else{
					sp.opacity = 0;
				}
			}
		});
		function touch(node,my){
			var px = node.cx * cls.bias; var py = node.cy * cls.bias;
			var add = my.size;
			var sx = my.x - add; var ex = my.x + add;
			var sy = my.z - add; var ey = my.z + add;
			if(px >= sx && px <= ex && py >= sy && py <= ey) return 1;
			return 0;
		}
	}
	//メイン
	this.main = function(){
		this.scene = scene;
		this.scene2D = scene2D;
		this.grid = [];
		this.texs = texs;
		this.SPs = [];
		this.items = [];
		this.lengX = x;
		this.lengY = y;
		this.size = 64;
		this.itemTypes = null;
		this.setItemAll = Math.floor((this.lengX * this.lengY) / 10);
		this.width = this.lengX * this.size;
		this.height = this.lengY * this.size;
		this.touching = 0;
		this.touchingDir = null;
		this.objTypes = null;
		this.objs = [];
		this.objStr = [];
		this.objsAll = Math.floor((this.lengX * this.lengY) / 20);
		this.objsInfosClear();
		this.clear();
		this.set();
		this.setPosition();
		this.makeSP();
		this.voyance = 0;
		this.makeMap(0,0,10);
	}
	this.main();
}

//アイテム発生クラス
function setItem(scene,scene2D,types,id,x,y){
	//surfセット
	this.setSF = function(){
		var type = this.info;
		var sf = this.sf;
		var ctx = this.sf.context;
		ctx.fillStyle = type.color;
		ctx.fillRect(0,0,sf.width,sf.height);
		ctx.lineWidth = this.sfSize / 10;
		ctx.strokeRect(0,0,sf.width,sf.height);
		var pw = sf.width;
		var ph = sf.height;
		var img = game.assets[type.img];
		sf.width = img.width;
		sf.height = img.height;
		sf.draw(img,0,0,img.width,img.height,0,0,sf.width,sf.height);
		sf._element.src = Math.random();
	}
	//id情報セット
	this.setInfo = function(){
		if(this.id != null) this.setID();
	}
	//idセット
	this.setID = function(id){
		if(id != null) this.id = id;
		this.info = this.types[this.id];
	}
	//enterframe
	this.setEnter = function(node){
		this.touchNode = node;						//タッチ用ノード
		this.canTouch = 1;
		var cls = this;
		this.sp.addEventListener("enterframe",function(){
			//取得処理
			if(cls.touchNode.intersect(this) && cls.canTouch){
				cls.canTouch = 0;
				cls.pick();
			}
		});
	}
	//消去処理
	this.del = function(){
		this.scene.removeChild(this.sp);
		this.sp = null;
		delete this.sp;
		delete this;
	}
	//取得処理
	this.pick = function(){
		//音声
		myItemSE.play(this.info.SEnum);
		mySubSE.play(0);
		//
		this.info.pickNum++;				//総取得数
		this.setMessage();
		this.onX = -screenWidth;
		this.onY = -screenHeight;
		var cls = this;
		cls.info.func();
		this.sp.delCount = 0;
		this.sp.addEventListener("enterframe",function(){
			var num = 0.1;
			var max = 1 / num;
			this.delCount++;
			this.scaleX -= num; this.scaleY -= num; this.scaleZ -= num;
			if(this.delCount >= max) cls.del();
		});
	}
	//取得アニメ
	this.setPickAnime = function(){
		//絵
		this.pcAnime = new Sprite();
		var sp = this.pcAnime;
		sp.opacity = 0;
		var scl = 1.5;
		sp.scale(scl,scl);
		var img = game.assets[this.info.img];
		sp.width = img.width;
		sp.height = img.height;
		sp.image = img;
		sp.x = screenWidth;
		sp.y = (screenHeight - sp.height) / 2;
		this.scene2D.addChild(sp);
		var time = 20;
		sp.tl.
		fadeTo(0.8,time / 4,eas).and().
		moveBy(-(sp.width * scl),0,time / 4,eas).and().
		scaleTo(scl / 2,scl * 2,time / 4,eas).
		scaleTo(scl * 2,scl / 2,time / 4,eas).
		scaleTo(scl,scl,time / 4,eas).
		delay(time).
		fadeTo(0,time,eas).
		then(function(){
			this.parentNode.removeChild(this);
			delete this;
		});
		//文字
		var str = this.info.name;
		var size = 120;
		var time = 5;
		for(var i=0; i<str.length; i++){
			var chr = new myText(this.scene2D,str[i],"myfont",size,screenWidth + (i * size / 2),screenHeight / 1.6);
			chr.sp.opacity = 0;
			chr.colors = [this.info.color,"rgba(0,0,0,1)","rgba(255,255,255,1)"];
			var num = i;
			chr.sp.tl.
			delay(time * num).
			fadeTo(1,time,eas).and().
			scaleTo(1.5,time,eas).and().
			moveBy(-screenWidth / 4,0,time,eas).
			scaleTo(1,time,eas).and().
			delay(time * 4).
			fadeTo(0,time,eas).
			then(function(){
				this.parentNode.removeChild(this);
				delete this;
			});
			chr.set();
		}
		//Flash
		makeFlash(scene2D,this.info.color,0.5,10);
	}
	//取得メッセージ処理
	this.setMessage = function(){
		this.setPickAnime();
		this.message = new myText(this.scene2D,this.info.txt,"myfont",this.txtSize,null,null);
		var mes = this.message;
		mes.sp.x = screenWidth - mes.sp.width;
		mes.sp.y = screenHeight - mes.sp.height;
		mes.sp.opacity = 0;
		var time = 30;
		mes.sp.tl.
		fadeTo(1,time).and().
		moveBy(0,-50,time,eas).
		delay(time).
		fadeTo(0,time).and().
		scaleTo(0,time,eas).
		then(function(){
			this.parentNode.removeChild(this);
			delete this;
		});
		mes.colors = [this.info.color,"rgba(0,0,0,1)","rgba(255,255,255,1)"];
		mes.setUnderCtx();
		mes.set();
	}
	//描画用セット
	this.setSP = function(){
		this.sp = new Box(this.size,this.size,this.size);
		this.sp.x = x;
		this.sp.z = y;
		this.sp.y = this.size * 1.5;
		this.bound = this.sp.bounding;
		this.bound.radius = this.size * 3;
		this.sf = new Surface(this.sfSize,this.sfSize);
		this.setSF();
		this.sp.mesh.texture.src = this.sf;
		this.sp.mesh.texture.ambient = [0.8,0.8,0.8,0.5];
		this.scene.addChild(this.sp);
		//発生アニメ
		this.sp.scaleX = 0; this.sp.scaleY = 0; this.sp.scaleZ = 0;
		var anime = function(){
			if(this.scaleX < 1){
				var num = 0.1;
				this.scaleX += num; this.scaleY += num; this.scaleZ += num;
			}else{
				this.scaleX = 1; this.scaleY = 1; this.scaleZ = 1;
				this.removeEventListener("enterframe",anime);
				//安定アニメ
				this.rotSpeed = 0.05;
				this.rotatePitch(rand(360)); this.rotateRoll(rand(360)); this.rotateYaw(rand(360));
				this.addEventListener("enterframe",function(){
					this.rotatePitch(this.rotSpeed / 3);
					this.rotateRoll(this.rotSpeed / 2);
					this.rotateYaw(this.rotSpeed);
				});
			}
		}
		this.sp.addEventListener("enterframe",anime);
	}
	//メイン
	this.main = function(){
		this.scene = scene;
		this.scene2D = scene2D;
		this.types = types;
		this.id = id;
		this.size = 8;
		this.sfSize = 256;
		this.txtSize = 50;
		this.setInfo();
	}
	this.main();
}

//アイテム情報セットクラス
function itemInfo(id,name,img,SEnum,color,func,txt){
	this.num = id;
	this.name = name;
	this.color = color;
	this.img = img;
	this.func = func;
	this.txt = txt;
	this.pickNum = 0;
	this.SEnum = SEnum;
}

//汎用ゲージセット
function setGauge(scene,time,size,x,y,func){
	//ゲージsurfセット
	this.setGaugeSf = function(){
		var sf = this.Gsp.sf;
		var ctx = sf.context;
		ctx.clearRect(0,0,sf.width,sf.height);
		ctx.fillStyle = centerGrad(sf,"rgba(255,0,0,1)","rgba(80,0,0,1)");
		ctx.fillRect(0,0,sf.width,sf.height);
		ctx.fillStyle = centerGrad(sf,"rgba(0,255,0,1)","rgba(0,80,0,1)");
		ctx.fillRect(0,0,sf.nowGwidth,sf.height);
		ctx.lineWidth = sf.height / 10;
		ctx.strokeStyle = centerGrad(sf,"rgba(0,0,0,1)","rgba(128,128,128,1)");
		ctx.strokeRect(0,0,sf.width,sf.height);
	}
	//スプライトへのsfセット
	this.setGaugeSfToSp = function(){
		this.setGaugeSf();
		this.Gsp.image = this.Gsp.sf;
	}
	//毎フレーム処理セット
	this.setEnter = function(){
		//毎フレーム処理
		var cls = this;
		var fade = 5;
		this.Gsp.addEventListener("enterframe",function(){
			this.sf.nowGwidth -= this.sf.deg;
			cls.setGaugeSfToSp();
			this.time++;
			if(this.time == cls.time){
				this.clearEventListener("enterframe");
				cls.func();
				this.tl.
				fadeTo(0,fade).
				then(function(){
					cls.scene.removeChild(this);
					delete this;
					delete cls;
				});
			}
		});
	}
	//描画道具セット
	this.setSP = function(){
		this.Gsp = new Sprite(this.size * 2,this.size / 2);
		var sp = this.Gsp;
		sp.time = 0;
		sp.x = x;
		sp.y = y;
		sp.sf = new Surface(sp.width,sp.height);
		sp.sf.nowGwidth = sp.sf.width;
		sp.sf.deg = sp.sf.nowGwidth / this.time;
		this.scene.addChild(sp);
	}
	//メイン処理
	this.main = function(){
		this.scene = scene;
		this.size = size;
		this.time = time;
		this.func = func;
		this.setSP();
		this.setGaugeSfToSp();
		this.setEnter();
	}
	this.main();
}

//ステータス表示クラス
function states(scene2D,size,barMax,x,y){
	//単体ステータスクラス
	function stClass(name,num,max,txtColor){
		//ステータス値ポイント化
		this.setPoint = function(){
			this.point = Math.floor(this.num / this.max * 10);
		}
		//メイン
		this.main = function(){
			this.name = name;
			this.num = num;
			this.max = max;
			this.txtColor = txtColor;
			this.spUP = 0;
		}
		this.main();
	}
	//スペシャルアップセット(funcは独自の更新等を差し込むため)
	this.setSPup = function(node,num,up,time,func){
		var st = this.STs[num];
		var cls = this;
		if(st.spUP == 0){
			st.spUP = up;						//上昇値セット
			node.spUP = st.spUP;				//実効値への反映
			cls.ref();							//描画更新
			if(func != null) func();
			//ゲージ呼び出し
			var x = this.sp.x + this.sp.width;
			var y = this.sp.y + num * this.size + this.size / 4;
			var gauge = new setGauge(this.scene,time,this.size,x,y,function(){
				//ゲージ切れ時処理
				cls.STs[num].spUP = 0;
				node.spUP = cls.STs[num].spUP;
				cls.ref();
				if(func != null) func();
			});
		}
	}
	//ステータスセット
	this.setST = function(name,num,max,txtColor){
		var st = new stClass(name,num,max,txtColor);
		this.STs.push(st);
	}
	//ステータス更新
	this.ref = function(){
		for(var i=0; i<this.STs.length; i++){
			this.STs[i].setPoint();
		}
		this.setSurf();
		this.sp.image = this.sf;
	}
	//surfセット
	this.setSurf = function(){
		var sf = this.sf;
		var ctx = sf.context;
		ctx.clearRect(0,0,sf.width,sf.height);
		ctx.beginPath();
		var str = this.STs;
		var rcolor = "rgba(255,255,255,0.5)";
		makeRoundTangle(sf,rcolor,rcolor,"rgba(255,255,255,0)");
		var tHeight = this.size / 1.2;
		var white = this.size / 10;
		for(var i=0; i<str.length; i++){
			var st = str[i];
			var x = 0;
			var y = i * this.size;
			ctx.beginPath();
			ctx.font = ""+this.size+"px myfont";
			var add = this.size / 20;
			ctx.fillStyle = "rgba(0,0,0,0.7)";
			ctx.fillText(st.name,add + white,add + y + tHeight,sf.width / 2);
			ctx.fillStyle = st.txtColor;
			ctx.fillText(st.name,white,y + tHeight,sf.width / 2);
			//ポイント描画(スペシャルアップも考慮)
			for(var j=0; j<(st.point + st.spUP); j++){
				var x = sf.width / 2;
				var width = sf.width / 2 / this.barMax / 2;
				var inter = 1.6;
				var grax = x + j * width * inter;
				var gray = y + white;
				var gra = ctx.createLinearGradient(grax,gray,grax + width,gray + this.size - white * 2);
				if(j<st.point){
					gra.addColorStop(0,"rgba(0,255,0,1)");
					gra.addColorStop(1,"rgba(0,0,0,1)");
				}else{
					gra.addColorStop(0,"rgba(255,255,0,1)");
					gra.addColorStop(1,"rgba(0,0,0,1)");
				}
				ctx.fillStyle = gra;
				ctx.fillRect(x + j * width * inter,y + white,width,this.size - white * 2);
			}
		}
	}
	//ステータス表示
	this.set = function(){
		this.sp = new Sprite(this.size * this.barMax,this.size * this.STs.length);
		if(x == null) x = this.size / 2;
		if(y == null) y = screenHeight - this.sp.height - this.size / 2;
		this.sp.x = x;
		this.sp.y = y;
		this.sf = new Surface(this.sp.width,this.sp.height);
		this.ref();
		this.scene.addChild(this.sp);
	}
	//メイン
	this.main = function(){
		this.STs = [];
		this.scene = scene2D;
		this.size = size;
		this.barMax = barMax;
	}
	this.main();
}

//固定オブジェクト発生クラス
function setObject(scene3D,scene2D,id,x,y,node){
	//情報セット
	this.setInfo = function(types){
		this.types = types;
		this.name = this.types[this.id].name;
		if(this.types[this.id].funcSub != null){
			this.types[this.id].funcSub(this);
		}
	}
	//スプライト毎フレーム処理セット
	this.setEnter = function(){
		var cls = this;
		this.sp.addEventListener("enterframe",function(){
			this.rotateYaw(0.1);
		});
	}
	//クリック時処理
	this.clickEV = function(){
		//音声
		myObjSE.play(this.types[this.id].SEnum);
		//
		var sp = this.sp;
		this.setTalkAnime();
		this.setMessage();
		sp.canTouch = 0;
		this.types[this.id].func(this);
		sp.count = 20;
	}
	//タッチ用ノード加算
	this.setTouch = function(scene2D){
		var cls = this;
		this.sp.canTouch = 1;
		this.sp.count = 0;
		this.touching = 0;
		this.sp.addEventListener("enterframe",function(){
			//範囲内
			if(cls.talkNode.touchTalk.intersect(this) && cls.talkNode.touchCount == 0){
				if(this.canTouch) cls.touching = 1;
			}else{
				cls.touching = 0;
			}
			//入力可能待機
			if(this.count > 0){
				this.count--;
			}else{
				this.count = 0;
				this.canTouch = 1;
			}
		});
	}
	//取得アニメ
	this.setTalkAnime = function(){
		//音声
		mySubSE.play(5);
		var type = this.types[this.id];
		//絵
		this.pcAnime = new Sprite();
		var sp = this.pcAnime;
		sp.opacity = 0;
		var scl = 1.5;
		sp.scale(0,0);
		var img = game.assets[type.img];
		sp.width = img.width;
		sp.height = img.height;
		sp.image = img;
		sp.x = screenWidth - sp.width * scl;
		sp.y = (screenHeight - sp.height) / 2;
		this.scene2D.addChild(sp);
		var time = 20;
		sp.tl.
		fadeTo(0.8,time / 2,eas).and().
		scaleTo(scl,scl,time,eas).and().
		rotateTo(360,time,eas).
		delay(time).
		fadeTo(0,time,eas).
		then(function(){
			this.parentNode.removeChild(this);
			delete this;
		});
		//文字
		var str = type.name;
		var size = 120;
		var time = 5;
		for(var i=0; i<str.length; i++){
			var chr = new myText(this.scene2D,str[i],"myfont",size,screenWidth / 1.4 + (i * size / 2),screenHeight / 1.6);
			chr.sp.opacity = 0;
			chr.colors = [type.iconColor,"rgba(0,0,0,1)","rgba(255,255,255,1)"];
			var num = i;
			chr.sp.tl.
			delay(time * num).
			fadeTo(1,time,eas).and().
			scaleTo(1.5,time,eas).and().
			rotateTo(360,time,eas).
			scaleTo(1,time,eas).and().
			rotateTo(720,time,eas).
			delay(time * 4).
			fadeTo(0,time,eas).
			then(function(){
				this.parentNode.removeChild(this);
				delete this;
			});
			chr.set();
		}
		//Flash
		makeFlash(this.scene2D,type.iconColor,0.5,10);
	}
	//取得メッセージ処理
	this.setMessage = function(){
		var type = this.types[this.id];
		this.message = new myText(this.scene2D,type.txt,"myfont",this.txtSize,null,null);
		var mes = this.message;
		mes.sp.x = screenWidth - mes.sp.width;
		mes.sp.y = screenHeight - mes.sp.height;
		mes.sp.opacity = 0;
		var time = 20;
		mes.sp.tl.
		fadeTo(1,time).and().
		moveBy(0,-50,time,eas).
		delay(time).
		fadeTo(0,time).and().
		scaleTo(0,time,eas).
		then(function(){
			this.parentNode.removeChild(this);
			delete this;
		});
		mes.colors = [type.iconColor,"rgba(0,0,0,1)","rgba(255,255,255,1)"];
		mes.setUnderCtx("rgba(0,255,0,1)","rgba(0,128,0,1)","rgba(255,255,255,1)");
		mes.set();
	}
	//スプライトセット
	this.setSP = function(){
		this.sp = new Plane(this.size);
		this.sp.angle = rand(360);
		this.sp.bounding.radius = this.size;
		this.sp.mesh.texture.ambient = [0.8,0.8,0.8,0.5];
		this.sp.x = x;
		this.sp.z = y;
		this.sp.y = this.size;
		this.sp.mesh.texture.src = this.types[this.id].img;
		this.scene.addChild(this.sp);
	}
	//メイン
	this.main = function(){
		this.scene = scene3D;
		this.scene2D = scene2D;
		this.talkNode = node;
		this.size = 15;
		this.id = id;
		this.txtSize = 50;
	}
	this.main();
}

//固定オブジェクト情報セットクラス
function setObjInfo(id,img,SEnum,func,color,type,funcSub,txt,name){
	this.id = id;
	this.img = img;
	this.func = func;
	this.iconColor = color;
	this.type = type;
	this.funcSub = funcSub;
	this.txt = txt;
	this.name = name;
	this.SEnum = SEnum;
}

//スコア表示
function makeScore(scene,score,size,x,y){
	//surfセット
	this.setSF = function(){
		var sf = this.sf;
		var ctx = sf.context;
		var white = this.size / 10;
		var title = "SCORE";
		ctx.lineWidth = this.size / 16;
		ctx.font = ""+this.size+"px myfont";
		var tWidth = ctx.measureText(this.txt).width;
		var titleWidth = ctx.measureText(title).width;
		ctx.clearRect(0,0,sf.width,sf.height);
		ctx.fillStyle = "rgba(255,255,255,1)";
		makeRoundTangle(sf,"rgba(0,255,0,0.8)","rgba(0,128,0,0.8)","rgba(0,0,0,0.5)");
		ctx.strokeStyle = centerGrad(sf,"rgba(0,0,0,1)","rgba(50,50,50,1)");
		ctx.strokeText(title,(sf.width - titleWidth) / 2,this.size - white,sf.width);
		ctx.fillStyle = centerGrad(sf,"rgba(0,255,0,1)","rgba(0,128,0,1)");
		ctx.fillText(title,(sf.width - titleWidth) / 2,this.size - white,sf.width);
		ctx.strokeText(""+this.score+"",(sf.width - tWidth) / 2,this.size * 2 - white,sf.width);
		ctx.fillStyle = centerGrad(sf,"rgba(255,255,0,1)","rgba(128,128,0,1)");
		ctx.fillText(""+this.score+"",(sf.width - tWidth) / 2,this.size * 2 - white,sf.width);
	}
	//更新アニメ
	this.refAnime = function(num,x,y){
		var sp = this.refSP;
		var sf = this.refSF;
		var ctx = sf.context;
		ctx.clearRect(0,0,sf.width,sf.height);
		var txt;
		if(num >= 0){
			txt = "+"+num+"";
		}else{
			txt = "-"+num+"";
		}
		ctx.font = ""+sf.height+"px myfont";
		var tWidth = ctx.measureText(txt).width;
		var white = sf.width / 10;
		ctx.lineWidth = white / 3;
		ctx.strokeStyle = "rgba(0,0,0,1)";
		ctx.strokeText(txt,(sf.width - tWidth) / 2,this.size,sf.width - white);
		ctx.fillStyle = "rgba(255,255,255,1)";
		ctx.fillText(txt,(sf.width - tWidth) / 2,this.size,sf.width - white);
		//描画
		var move = 30;
		var time = 10;
		this.scene.removeChild(sp);
		sp.x = sp.fx;
		sp.y = sp.fy;
		this.scene.addChild(sp);
		sp.tl.clear().
		fadeTo(1,time,eas).and().
		moveBy(0,-move,time,eas).
		delay(time * 4).
		fadeTo(0,time,eas).
		then(function(){
			this.parentNode.removeChild(this);
		});
	}
	//スコア更新
	this.ref = function(num){
		var temp = Math.floor(this.score + num);
		if(temp < this.min){
			this.score = this.min;
		}else
		if(temp > this.max){
			this.score = this.max;
		}else{
			this.score += num;
		}
		this.refImg(num);
	}
	//イメージのセット
	this.refImg = function(num){
		this.setTxt();
		this.setSF();
		this.sp.image = this.sf;
		if(num != null){
			this.refAnime(num);
			this.refSP.image = this.refSF;
		}
	}
	//テキストセット
	this.setTxt = function(){
		this.txt = ""+this.score+"";
	}
	//道具セット
	this.setSP = function(){
		this.sp = new Sprite(this.size * 4,this.size * 2);
		this.sp.x = x;
		this.sp.y = y;
		this.sf = new Surface(this.sp.width,this.sp.height);
		this.scene.addChild(this.sp);
		this.refSP = new Sprite(this.sp.width,this.sp.height / 2);
		this.refSP.opacity = 0;
		this.refSP.x = x + this.sp.width * 1.2;
		this.refSP.y = y + this.sp.height / 2;
		this.refSP.fx = this.refSP.x;
		this.refSP.fy = this.refSP.y;
		this.refSF = new Surface(this.refSP.width,this.refSP.height);
		this.scene.addChild(this.refSP);
	}
	//メイン
	this.main = function(){
		this.scene = scene;
		this.score = score;
		this.size = size;
		this.min = 0;
		this.max = 9999999;
		this.setSP();
		this.refImg();
	}
	this.main();
}

//リザルト画面シーンクラス
function makeResult(time,courseTime,timeText,score,allItem,func,ranksClass,difClass){
	//カメラセット
	this.setCamera = function(x,y,z){
		this.camera = new Camera3D();
		var cmr = this.camera;
		cmr.x = x; cmr.y = y; cmr.z = z;
		cmr.lookAt(this.SWK);
		cmr.count = 0;
		this.scene3D.setCamera(cmr);
		//SWK様にカメラを近づける
		var cls = this;
		var chs = function(){
			var pos = 60;
			cmr.chase(this,pos,10);
			var x = -10; var y = 13;
			cmr.x = x; cmr.y = y;
			cmr.centerX = x; cmr.centerY = y;
			cmr.count++;
			if(cmr.count == 60){
				cls.SWK.removeEventListener("enterframe",chs);
			}
		}
		this.SWK.addEventListener("enterframe",chs);
	}
	//ライトセット
	this.setLight = function(x,y,z,c1,c2,c3){
		this.light = new DirectionalLight();
		var lgt = this.light;
		lgt.directionX = x; lgt.directionY = y; lgt.directionZ = z;
		lgt.color = [c1,c2,c3];
		this.scene3D.setDirectionalLight(lgt);
	}
	//SWK様セット
	this.setSWK = function(num,anime){
		this.SWK = game.assets[models[num]].clone();
		this.SWK.addEventListener("enterframe",function(){
			this.pushAnimation(game.assets[motions[anime]]);
		});
		this.scene3D.addChild(this.SWK);
		this.Clear.set(this.SWK);
	}
	//スコアリザルトクラス
	function oneResult(txt,colors,size){
		this.txt = txt;
		this.colors = colors;
		if(size == null){
			this.size = 43;
		}else{
			this.size = size;
		}
	}
	//リザルトテキストセット
	this.setTexts = function(){
		this.txts = [];
		var str = this.txts;
		//以下定義
		str.push(new oneResult("残り時間"+this.timeText+"",[0,255,255,1]));
		str.push(new oneResult("⇒時間倍率ボーナス"+this.timeMag+"",[255,0,0,1]));
		str.push(new oneResult("×",[100,100,100,1]));
		str.push(new oneResult("ゲームスコア",[0,255,255,1]));
		str.push(new oneResult(""+this.score+"",[0,255,0,1]));
		str.push(new oneResult("＋",[100,100,100,1]));
		str.push(new oneResult("アイテム取得数ボーナス",[0,255,255,1]));
		str.push(new oneResult(""+this.allItem+" × "+this.itemBias+"",[0,0,255,1]));
		str.push(new oneResult("||",[100,100,100,1]));
		str.push(new oneResult("トータル",[255,255,0,1],50));
		str.push(new oneResult(""+this.total+"",[255,0,255,1],55));
	}
	//PUSHセット
	this.setPush = function(){
		var size = 100;
		var cls = new myText(this.scene2D,"PUSH「Z」","myfont",size,null,null);
		var sp = cls.sp;
		sp.opacity = 0;
		cls.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
		var time = 20;
		sp.tl.fadeTo(1,time / 2,eas).
		then(function(){
			sp.tl.
			scaleTo(0.8,0.8,time,eas).
			scaleTo(1,1,time,eas).
			loop();
		});
		cls.set();
		sp.x = screenWidth - sp.width;
		sp.y = screenHeight - sp.height;
		var self = this;
		sp.addEventListener("enterframe",function(){
			if(game.input.z){
				self.Clear.clear();
				//追加処理が行われていた場合は名前入力呼び出し
				var str = self.ranksClass.lastChange;
				if(str[0] != null && str[1] != null){
					//入力フォーム
					var input = new setInputForm(null,null,null,null,null,null,null,yourName,function(){
						//音声
						mySWKSE.play(6);
						//名前書換
						yourName = input.form._element.value;
						self.ranksClass.rankings[str[0]].infos[str[1]].str[2] = yourName;
						func();
					});
					input.form.y = Math.floor(screenHeight / 4) * 3;
					//BGM再生
					myBGM.play(input.scene,1);
					//背景
					var sp = new Sprite(screenWidth,screenHeight);
					var sf = new Surface(sp.width,sp.height);
					var ctx = sf.context;
					ctx.strokeStyle = centerGrad(sf,"rgba(0,255,0,1)","rgba(0,128,0,1)");
					monocheck(sf);
					ctx.lineWidth = screenWidth / 30;
					ctx.strokeRect(0,0,sf.width,sf.height);
					sp.image = sf;
					input.scene.addChild(sp);
					//右往左往
					var loop1 = new makeLoopPicture(input.scene,pics[5],320,280,7,10,-1);
					var loop2 = new makeLoopPicture(input.scene,pics[6],300,300,9,3,1);
					//レイヤー調整
					input.scene.removeChild(input.lab);
					input.scene.addChild(input.lab);
					//スコア更新
					var title = new myText(input.scene,"スコア更新！成し遂げたぜ。","myfont",90,null,10);
					var sp = title.sp;
					sp.opacity = 0;
					title.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
					sp.tl.fadeTo(1,10,eas).
					then(function(){
						this.tl.
						scaleTo(0.8,0.8,10,eas).
						scaleTo(1,1,10,eas).
						loop();
					});
					title.set();
					sp.x = (screenWidth - sp.width) / 2;
					sp.y = sp.height / 3;
					//名前入力してね！
					var cls = new myText(input.scene,"名前を入力するわっ！(エンターキーで決定！)","myfont",50,null,10);
					var sp = cls.sp;
					sp.opacity = 1;
					cls.colors = ["rgba(0,0,255,1)","rgba(0,0,128,1)","rgba(255,255,255,1)"];
					cls.set();
					sp.x = (screenWidth - sp.width) / 2;
					sp.y = screenHeight - sp.height * 2;
				}else{
					func();
				}
			}
		});
	}
	//スコアリザルト表示
	this.setResultShow = function(){
		var txts = this.txts;
		var outline = 18;
		var setY = 0;
		var time = 7;
		var allTime = txts.length * time / 2;
		for(var i=0; i<txts.length; i++){
			var cls = new myText(this.scene2D,txts[i].txt,"myfont",txts[i].size,null,null);
			var sp = cls.sp;
			sp.opacity = 0;
			sp.scale(2,2);
			var cs = txts[i].colors;
			cls.colors = 	[	"rgba("+cs[0]+","+cs[1]+","+cs[2]+","+cs[3]+")",
								"rgba("+Math.floor(cs[0]/2)+","+Math.floor(cs[1]/2)+","+Math.floor(cs[2]/2)+","+Math.floor(cs[3])+")",
								"rgba(255,255,255,1)"
							];
			var num = time / 2 * i;
			sp.tl.
			delay(num).then(function(){
				//音声
				mySubSE.play(4);
			}).
			fadeTo(1,time,eas).and().
			scaleTo(1,1,time,eas);
			cls.set();
			sp.x = this.scr.x + this.scr.width / 2 - sp.width / 2;
			sp.y = this.scr.y + outline + setY;
			setY += txts[i].size;
		}
		//PUSHセット用ディレイ
		var ent = new Entity();
		this.scene2D.addChild(ent);
		var cls = this;
		ent.tl.
		delay(allTime).
		then(function(){
			this.parentNode.removeChild(this);
			cls.setPush();
		});
	}
	//画面surf
	this.setScreenSF = function(){
		var sf = this.scr.sf;
		var ctx = sf.context;
		makeSNTwindowSF(sf,40);
	}
	//画面セット
	this.setScreen = function(){
		scene3D.backgroundColor = [1,0.5,0.7,0.8];
		var white = Math.floor(screenHeight / 16);
		this.scr = new Sprite(Math.floor(screenWidth / 1.8),screenHeight - white);
		var sp = this.scr;
		sp.x = 20;
		sp.y = -screenHeight + white / 2;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		this.setScreenSF();
		sp.image = sf;
		this.scene2D.addChild(sp);
		var time = 30;
		var cls = this;
		sp.tl.
		moveBy(0,screenHeight,time,eas).
		then(function(){
			cls.setResultShow();
		});
	}
	//トータル計算
	this.setTotal = function(){
		this.total = Math.floor( Math.floor(this.timeMag * this.score) + Math.floor(this.allItem * this.itemBias));
	}
	//時間からの倍率計算
	this.setTimeMag = function(){
		this.timeMag = (Math.floor(this.time / 180) / 100 + 1).toFixed(2);
	}
	//ランキングへの追加処理
	this.setRanking = function(){
		var num = this.difClass.dif;
		this.ranksClass.insertAuto(num,this.total,this.courseTime,yourName);
	}
	//メイン
	this.main = function(){
		this.scene2D = new Scene();
		game.pushScene(this.scene2D);
		//BGM再生
		myBGM.play(this.scene2D,1);
		this.Clear = new gameClear(scene3D);
		this.scene3D = scene3D;
		this.time = time;
		this.courseTime = courseTime;
		this.timeText = timeText;
		this.score = score;
		this.allItem = allItem;
		this.itemBias = 333;
		this.ranksClass = ranksClass;
		this.difClass = difClass;
		this.setTimeMag();
		this.setTotal();
		this.setTexts();
		this.setScreen();
		this.setSWK(0,5);
		this.setCamera(0,600,600);
		this.setLight(0,100,100,1,1,1);
		this.setRanking();
	}
	this.main();
}