//モデルセット
function setModel(scene,angle,num,x,y,z,anime,SWK,stop){
	var mod = game.assets[models[num]].clone();
	mod.scene = scene;
	mod.x = x; mod.y = y; mod.z = z;
	mod.angleX = 0; mod.angleY = 0; mod.angleZ = 0;
	mod.vx = 0; mod.vy = 0; mod.vz = 0;				//移動ベクトル用
	mod.speed = 9;									
	mod.speedAtend = 0;								//加算スピード
	mod.speedAtendMax = 5;							//加算スピード上限
	mod.changeAnime = 1;
	//スペシャルアップ
	mod.spUP = 0;
	//ポイント加算を加味したスピード
	mod.trueSpeedSet = function(){
		this.trueSpeed = this.speed + this.speedAtend + this.spUP * this.speedAtendMax / 10;
	}
	mod.trueSpeedSet();
	//スピード加算処理 * 1
	mod.speedAtending = function(){
		if(this.speedAtend < this.speedAtendMax){
			this.speedAtend += this.speedAtendMax / 10;
		}else{
			this.speedAtend = this.speedAtendMax;
		}
		this.trueSpeedSet();
	}
	mod.rotSpeed = null;
	mod.moving = 0;
	mod.nowAnime = null;
	mod.anime = anime;
	//タッチ判定用スプライト
	mod.touchSP = new Sprite3D();
	mod.touchSP.onenterframe = function(){
		this.x = mod.x; this.y = mod.y; this.z = mod.z;
	}
	//タッチ判定用
	mod.touchNode = 0;
	mod.touchNode.touching = 0;
	//回転
	mod.rotate = function(x,y,z){
		if(x != 0){
			this.rotatePitch(x * Math.PI / 180);
			this.angleX += x;
		}
		if(z != 0){
			this.rotateRoll(z * Math.PI / 180);
			this.angleZ += z;
		}
		if(y != 0){
			this.rotateYaw(y * Math.PI / 180);
			this.angleY += y;
		}
	}
	mod.rotate(0,angle,0);				//初期角度セット
	//トーク範囲セット
	mod.setTalk = function(scene2D,scale){
		mod.touchTalk = new Sphere();
		var sp = mod.touchTalk;
		sp.scale = scale;
		sp.mat = new mat4.create();
		var bound = sp.bounding;
		bound.type = "AABB";
		sp.radAtend = 0;
		sp.radAtendMax = scale * 1.5;
		sp.spUP = 0;
		//ポイント加算を加味したサイズ
		sp.truePointSet = function(){
			bound.radius = this.scale + this.radAtend + sp.spUP * this.radAtendMax / 10;		//スペシャルアップも加味
			this.scaleX = bound.radius;
			this.scaleZ = bound.radius;
		}
		sp.truePointSet();
		//ポイント加算処理 * 1
		sp.pointAtending = function(){
			if(this.radAtend < this.radAtendMax){
				this.radAtend += this.radAtendMax / 10;
			}else{
				this.radAtend = this.radAtendMax;
			}
			this.truePointSet();
		}
		//surfセット
		sp.surfSet = function(num){
			var sf = this.sf;
			var ctx = sf.context;
			ctx.clearRect(0,0,sf.width,sf.height);
			if(num == 1){
				ctx.fillStyle = "rgba(0,0,255,0.5)";
				ctx.fillRect(0,0,sf.width,sf.height);
			}else if(num == 2){
				ctx.fillStyle = "rgba(255,0,0,0.5)";
				ctx.fillRect(0,0,sf.width,sf.height);
			}
			sf._element.src = Math.random();
			this.mesh.texture.src = sp.sf;
		}
		sp.sf = new Surface(scale,scale);
		sp.sfNum = 1;
		sp.surfSet(sp.sfNum);
		//毎フレーム処理
		sp.onenterframe = function(){
			this.angle = mod.angleY;
			mat4.identity(this.mat);
			mat4.rotateY(this.mat,this.angle * Math.PI / 180);
			this.rotation = this.mat;
			var ang = mod.angleY * Math.PI / 180;
			var startX = mod.x + Math.sin(ang) * bound.radius;
			var startZ = mod.z + Math.cos(ang) * bound.radius;
			this.x = startX;
			this.z = startZ;
		}
		mod.scene.addChild(sp);
		//talk判定
		var touchCountMax = 20;
		mod.touchCount = touchCountMax;
		var self = mod;
		mod.touchTalk.touchTalkingFlash = function(){
			if(game.input.z && self.touchCount == 0){
				self.touchCount = touchCountMax;
				//発光アニメ開始
				sp.sfNum = 2;
				sp.surfSet(sp.sfNum);
				//音声
				mySWKSE.play(7);
			}
			if(self.touchCount > 0){
				self.touchCount--;
			}else if(sp.sfNum == 2){
				//発光アニメ終了
				sp.sfNum = 1;
				sp.surfSet(sp.sfNum);
			}
		}
		mod.touchTalk.addEventListener("enterframe",mod.touchTalk.touchTalkingFlash);
		//talkラベル
		mod.touchLabel = new Sprite(Math.floor(screenWidth / 2),Math.floor(screenHeight / 9));
		var sprite = mod.touchLabel;
		sprite.on = 0;
		sprite.x = (screenWidth - sprite.width) / 2;
		sprite.y = screenHeight / 4 - sprite.height / 2;
		var sf = new Surface(sprite.width,sprite.height);
		tsukamaetaSurf(sf);
		sprite.image = sf;
		sprite.onenterframe = function(){
			if(this.on){
				this.opacity = 1;
			}else{
				this.opacity = 0;
			}
		}
		scene2D.addChild(sprite);
	}
	//トーク対象セット　
	mod.setTalkNode = function(node,func){
		this.canTalk = node;
		node.addEventListener("enterframe",function(){
			var tSP = mod.touchTalk;
			if(tSP.intersect(this) && mod.touchCount == 0){
				mod.touchLabel.on = 1;
				if(game.input.z) func();
			}else{
				mod.touchLabel.on = 0;
			}
		});
	}
	//行動抑制用
	mod.canMove = 1;
	//回転初速初期化
	mod.fRrot = mod.rotSpeed;
	mod.fLrot = mod.rotSpeed;
	mod.frotP = 1;
	//SE用
	if(option.elements[4].num == 1){
		mod.SEmax = 4;
		mod.runAnime = 6;
		mod.runSe = 0;
	}else{
		mod.SEmax = 9;
		mod.runAnime = 1;
		mod.runSe = 7;
	}
	mod.SEcount = mod.SEmax - 1;
	//stop時は最初の一回だけ
	if(stop){
		mod.pushAnimation(game.assets[motions[mod.anime]]);
	}else{
		//毎フレーム処理
		mod.onenterframe = function(){
			//回転速度はスピード / 3 + 1
			this.rotSpeed = Math.floor(this.trueSpeed / 2.5 + 1);
			//アニメ初期化
			this.moving = 0;
			//アニメ呼び出し
			if(this.changeAnime){
				if(this.nowAnime != this.anime) this.clearAnimation(game.assets[motions[this.nowAnime]]);
				this.pushAnimation(game.assets[motions[this.anime]]);
				this.nowAnime = this.anime;
			}
			//SWK様の場合
			if(SWK){
				//タッチ処理が入っている場合に深入りしていた場合の強制押出し
				if(mod.moveBack()) return 1;
				//処理群
				if(mod.canMove){
					var In = game.input;
					if(!In.z){
						//上
						if(In.up){
							//音声
							this.SEcount++;
							if(this.SEcount >= this.SEmax){
								this.SEcount = 0;
								mySWKSE.play(this.runSe);
							}
							this.anime = this.runAnime;
							this.move(1);
							this.moving = 1;
						}
						//下
						if(In.down){
							this.move(-0.5);
							this.moving = 1;
							this.anime = 2;
						}
						//左
						if(In.left){
							this.rotate(0,this.rotSpeed - this.fLrot,0);
							if(this.fLrot > 0){
								this.fLrot -= this.frotP;
							}else{
								this.fLrot = 0;
							}
						}else{ this.fLrot = this.rotSpeed; }		//回転初速初期化
						//右
						if(In.right){
							this.rotate(0,-(this.rotSpeed - this.fRrot),0);
							if(this.fRrot > 0){
								this.fRrot -= this.frotP;
							}else{
								this.fRrot = 0;
							}
						}else{ this.fRrot = this.rotSpeed; }		//回転初速初期化
						//反転
						if(In.x) this.returning();
					}
				}
				//入力が無かった場合は待機アニメ
				if(this.moving == 0 && mod.changeAnime){
					this.anime = 0;
					this.SEcount = this.SEmax - 1;
				}
			}
		}
	}
	//反転処理
	mod.rotating180 = function(){}
	mod.returning = function(){
		this.canMove = 0;
		var allAngle = 0;
		var angle = 180 / ((this.speedAtendMax - this.speedAtend) + 15);
		//音声
		mySWKSE.play(4);
		this.rotating180 = function(){
			this.rotate(0,angle,0);
			allAngle += angle;
			if(allAngle >= 180){
				this.rotate(0,-(allAngle - 180),0);
				this.removeEventListener("enterframe",this.rotating180);
				this.canMove = 1;
			}
		}
		this.addEventListener("enterframe",this.rotating180);
	}
	//衝突判定セット
	mod.setTouch = function(node){
		mod.touchNode = node;
	}
	//移動処理
	mod.move = function(vec){
		this.vx = Math.sin(this.angleY * Math.PI / 180) * this.trueSpeed * vec;
		this.vz = Math.cos(this.angleY * Math.PI / 180) * this.trueSpeed * vec;
		var mx = this.x + this.vx;
		var mz = this.z + this.vz;
		this.touchSP.x = mx;
		this.touchSP.z = mz;
	}
	//壁判定後の戻る処理
	mod.moveBack = function(){
		if(mod.touchNode.touching){
			var move = this.trueSpeed / 1;
			switch(mod.touchNode.touchingDir){
				case 1: this.z += move; break;
				case 2: this.x += move; break;
				case 3: this.x -= move; break;
				case 4: this.z -= move; break;
			}
		}
		return 0;
	}
	//上空カメラ
	mod.backCamera = function(camera,dist){
		var ang = this.angleY * Math.PI / 180;
		camera.centerX = Math.sin(ang) + this.x;
		camera.centerY = this.y + dist / 6;
		camera.centerZ = Math.cos(ang) + this.z;
		camera.x = this.x - Math.sin(ang) * dist;
		camera.y = this.y + dist / 5;
		camera.z = this.z - Math.cos(ang) * dist;
	}
	//ワープ
	mod.warp = function(x,y){
		var time = 6;
		var num = 0.2;
		var sp = this;
		sp.canMove = 0;
		waiting(time,function(){
			sp.x = x;
			sp.z = y;
			waiting(time,function(){
				sp.canMove = 1;
			},function(){
				if(sp.scaleX < 1){
					sp.scaleX += num; sp.scaleY += num; sp.scaleZ += num;
				}else{
					sp.scaleX = 1; sp.scaleY = 1; sp.scaleZ = 1;
				}
			});
		},function(){
			if(sp.scaleX > 0.1){
				sp.scaleX -= num; sp.scaleY -= num; sp.scaleZ -= num;
			}else{
				sp.scaleX = 0.1; sp.scaleY = 0.1; sp.scaleZ = 0.1;
			}
		});
	}
	//タッチトークとタッチスプライト消去
	mod.clearSubSP = function(){
		scene3D.removeChild(this.touchTalk);
		scene3D.removeChild(this.touchSP);
	}
	//クリアアニメ
	mod.allClearAnime = function(camera,func){
		mod.callClearAnime = function(){
			var myscene = new Scene();
			game.pushScene(myscene);
			//アニメ1
			this.anime = 7;
			this.pushAnimation(game.assets[motions[this.anime]]);
			//
			myscene.count = 0;
			myscene.sph = null;
			var sph = myscene.sph;
			var sphOpa = 1;
			//暗転用
			var white = new Sprite(screenWidth,screenHeight);
			white.opacity = 0;
			myscene.addChild(white);
			var sf = new Surface(white.width,white.height);
			var ctx = sf.context;
			ctx.fillStyle = "rgba(255,255,255,1)";
			ctx.fillRect(0,0,sf.width,sf.height);
			white.image = sf;
			//アニメ群
			myscene.addEventListener("enterframe",function(){
				var self = this;
				this.count++;
				var cnt = this.count;
				if(cnt >= 25 && cnt <= 60){
					mod.y += 10;
					camera.y += 5;
					camera.lookAt(mod);
				}
				else
				if(cnt == 61){
					//音声
					mySWKSE.play(3);
					setSNTClear(1,function(){
						//音声
						mySubSE.play(7);
						sph = new Sphere(1);
						sph.mesh.texture.src = game.assets[pics[1]];
						sph.mesh.setBaseColor([1, 1, 1, sphOpa]);
						sph.x = mod.x; sph.y = mod.y + 40; sph.z = mod.z;
						scene3D.addChild(sph);
						mod.anime = 8;
						mod.pushAnimation(game.assets[motions[mod.anime]]);
						sph.addEventListener("enterframe",function(){
							this.rotateYaw(0.1);
						});
					});
				}
				else
				if(cnt >= 62 && cnt <= 100){
					var num = 0.5;
					sph.scaleX += num; sph.scaleY += num; sph.scaleZ += num;
					camera.y += 10;
				}
				else
				if(cnt == 101){
					setSNTClear(2,function(){
						//音声
						mySWKSE.play(6);
						mod.anime = 9;
						mod.pushAnimation(game.assets[motions[mod.anime]]);
					});
				}
				else
				if(cnt >= 103 && cnt <= 150){
					if(cnt <= 125){
						sph.y -= 15;
						var num = 0.9;
						sph.scaleX -= num; sph.scaleY -= num; sph.scaleZ -= num;
					}
					camera.rotateRoll(0.01);
					camera.y += 4;
				}
				else
				if(cnt == 151){
					sph.mesh.texture.src = game.assets[pics[2]];
					//音声
					mySubSE.play(6);
				}else
				if(cnt >= 152 && cnt <= 225){
					var num = 20;
					sph.scaleX += num; sph.scaleY += num / 10; sph.scaleZ += num;
					if(cnt >= 200){
						scene3D.removeChild(mod.canTalk);
						sphOpa -= 0.05;
					}
					sph.mesh.setBaseColor([1, 1, 1, sphOpa]);
					camera.rotateRoll(0.01);
					camera.y;
				}else
				if(cnt == 226){
					sph.clearEventListener("enterframe");
					scene3D.removeChild(sph);
					mod.anime = 10;
					mod.addEventListener("enterframe",function(){
						mod.pushAnimation(game.assets[motions[mod.anime]]);
					});
					var dist = 80;
					var ang = (mod.angleY + 70) * Math.PI / 180;
					camera.x = mod.x + Math.sin(ang) * dist;
					camera.y = mod.y;
					camera.z = mod.z + Math.cos(ang) * dist;
					camera.lookAt(mod);
					camera.centerY += 15;
					camera.y += 15;
					setSNTClear(3,function(){
						//音声
						mySWKSE.play(1);
						white.tl.
						fadeTo(1,30).
						then(function(){
							self.clearEventListener("enterframe");
							//シーン消去
							scene2DallClear(this.parentNode);
							func();
						});
						self.addEventListener("enterframe",function(){
							myBGM.BGM.volume /= 1.1;
							myBGM.BGM.volume = Math.floor(myBGM.BGM.volume * 100) / 100;
						});
					});
					camera.rotateRoll(0.01);
				}
			});
		}
		//いろいろ準備
		this.clearSubSP();
		this.changeAnime = 0;
		this.clearAnimation(game.assets[motions[this.nowAnime]]);
		var myscene = new Scene();
		game.pushScene(myscene);
		var KZ = mod.canTalk;
		camera.x = KZ.x; camera.y = KZ.y + 80; camera.z = KZ.z + 80;
		camera.lookAt(KZ);
		//BGM再生
		myBGM.play(myscene,810);
		myBGM.play(myscene,0);
		//catching
		this.text = new myText(myscene,"処刑開始+⌒～⌒+","myfont",90,null,10);
		var text = this.text;
		text.sp.opacity = 0;
		text.colors = ["rgba(255,0,0,1)","rgba(128,0,0,1)","rgba(255,255,255,1)"];
		text.sp.tl.
		fadeTo(1,10,eas).
		delay(20).
		fadeTo(0,10,eas).
		then(function(){
			myscene.removeChild(this);
			scene2DallClear();
			if(option.elements[3].num == 2){
				mod.backCamera(camera,100);
				mod.callClearAnime();
			}else{
				func();
			}
		});
		text.set();
		text.sp.x = (screenWidth - text.sp.width) / 2;
		text.sp.y = (screenHeight - text.sp.height) / 2;
	}
	//返却
	return mod;
}

//クリアアニメ用1
function setSNTClear(num,func){
	var backFPS = game.fps;
	game.fps = 60;
	var SNTwin = new makeSNTwindow(function(){
		game.fps = backFPS;
		func();
	});
	//BGMクラス追加
	SNTwin.setBGMclass(myBGM);
	//SEクラス追加
	SNTwin.setSEclass(mySubSE);
	//ページ追加
	setPagesClear(num);
	SNTwin.start();
	
	function setPagesClear(num){
		switch(num){
			case 1:
				SNTwin.pushPage(null,standPics[0],400,500,0,null,null,null,
					"すわっっっっっっっっっっっっ！！！！！！（デスボール）");
				break;
			case 2:
				SNTwin.pushPage(null,standPics[0],400,500,0,null,null,null,
					"知らなかったのか");
				SNTwin.pushPage(null,standPics[0],400,500,1,null,null,null,
					"大魔王からは逃げられない");
				break;
			case 3:
				SNTwin.pushPage(null,standPics[0],400,500,0,null,null,null,
					"ALISON・・・");
				SNTwin.pushPage(null,standPics[0],400,500,0,null,null,null,
					"お前はそこで乾いてゆけ");
				break;
		}
	}
}