function gameSet(){
	window.scroll(0,0);
	//グローバル変数セット
	screenWidth = 1024;
	screenHeight = 576;
	game = new Core(screenWidth,screenHeight);
	game.fps = 26;
	eas = enchant.Easing.QUAD_EASEINOUT;					//汎用イージング
	nowDif = null;											//難易度設定用クラス
	scene3D = new Scene3D();								//3Dシーンは単体
	scene3D.backgroundColor = [0,0,0,1];
	Rankings = null;										//ランキング情報セット用クラス
	yourName = "一般通過SWK信徒";
	//キーバインド
	function bind(key){ game.keybind(key.charCodeAt(0) - 32, key); }
	bind("z"); bind("x"); bind("c"); bind("g"); bind("d");
	game.keybind(32,"space");
	game.keybind(13,"enter");
	//新規ローディングシーン
	makeLoadScene();
	//プリロードまとめ
	loadSetting();
	//ゲーム開始
	game.onload = function(){
		title();
	}
	//ゲーム処理開始
	game.start();
}

//SEセットまとめ
function loadSetting(){
	//プリロード
	function loads(str,path){
		if(path == null) path = "";
		for(var i=0; i<str.length; i++){
			str[i] = ""+path+""+str[i]+"";
			if(str[i] != "null") game.preload(str[i]);
		}
	}
	//オプション情報セット
	option = new optionScene(40,100,150);
	var str = localStorage.getItem("option");
	option.push(5,1,"BGM音量");
	option.push(10,1,"SE音量");
	option.push(4,1,"オブジェクト描画範囲");
	option.push(2,0,"SWK様イベント省略");
	option.push(1,0,"十傑集走り");
	if(str != null){
		str = JSON.parse(str);
		option.setLoadString(str);
	}
	/*
	-------------------------------------------------------------------------------------------------------------
	*/
	//BGMセット
	BGMs = ["BGM1.mp3","BGM2.mp3","BGM3.mp3","BGM4.mp3","BGM5.mp3"];
	loads(BGMs,"BGM/");
	myBGM = new setLoopBGM(BGMs);					//BGM再生用クラス
	myBGM.setVol(0,0.8);
	myBGM.setVol(1,0.3);
	myBGM.setVol(2,0.8);
	myBGM.setVol(3,0.4);
	myBGM.setVol(4,0.6);
	//アイテムSE
	itemSEs = ["item1.mp3","item2.mp3","item3.mp3","item4.mp3"];
	loads(itemSEs,"SE/");
	myItemSE = new setSE(itemSEs);				//itemSE再生用クラス
	myItemSE.setVol(0,1);
	myItemSE.setVol(1,1);
	myItemSE.setVol(2,1);
	myItemSE.setVol(3,1);
	//オブジェSE
	objSEs = ["obj1.mp3","obj2.mp3","obj3.mp3","obj4.mp3","obj5.mp3","obj6.mp3"];
	loads(objSEs,"SE/");
	myObjSE = new setSE(objSEs);				//itemSE再生用クラス
	myObjSE.setVol(0,1);
	myObjSE.setVol(1,1);
	myObjSE.setVol(2,1);
	myObjSE.setVol(3,1);
	myObjSE.setVol(4,1);
	myObjSE.setVol(5,1);
	//SWK様SE
	SWKSEs = ["SWK_hora.mp3","SWK_kerokerori.mp3","SWK_suwa.mp3","SWK_suwawa1.mp3","SWK_suwawa2.mp3","SWK_waraenaiyo.mp3","SWK_hore.mp3","SWK_hoi.mp3","SWK_su.mp3"];
	loads(SWKSEs,"SE/");
	mySWKSE = new setSE(SWKSEs);				//SWK様SE再生用クラス
	mySWKSE.setVol(0,0.3);
	mySWKSE.setVol(7,0.5);
	//汎用SE
	subSEs = ["maou_sys_46.mp3","YN_korosukara.mp3","NSDR_flash.mp3","YTR_iguzo.mp3","SE_ban.mp3","maou_sys_47.mp3","maou_exp_2.mp3","maou_mag_2.mp3","maou_sys_13.mp3"];
	loads(subSEs,"SE/");
	mySubSE = new setSE(subSEs);				//汎用SE再生用クラス
	mySubSE.setVol(0,0.4);
	mySubSE.setVol(2,0.3);
	mySubSE.setVol(3,0.4);
	mySubSE.setVol(8,0.6);
	//現場監督
	kantokuSEs = [];
	var num = 25;
	for(var i=0; i<num; i++){
		kantokuSEs.push(""+(i+1)+".mp3");
	}
	loads(kantokuSEs,"SE/kantoku/");
	kantokuSE = new setSE(kantokuSEs);				//現場監督SE再生用クラス
	for(var i=0; i<num; i++){
		kantokuSE.setVol(i,0.7);
	}
	/*
	-------------------------------------------------------------------------------------------------------------
	*/
	//ピクチャ
	pics = ["title.jpg","death_texture.png","explosion.jpg","zenza.png","sky.jpg","SWK_run.png","KAERU_run.png","back1.jpg","back2.jpg","kantoku.png","morisute.png","kibori.png"];
	loads(pics,"picture/");
	//アイテム用テクスチャ
	itemTexs = ["item1.png","item2.png","item3.png","item4.png"];
	loads(itemTexs,"texture/");
	//固定オブジェ用テクスチャ
	objTexs = ["obj1.png","obj2.png","obj3.png","obj4.png","obj5.png","obj6.png"];
	loads(objTexs,"texture/");
	//床用テクスチャ
	floorTexs = ["floor1.png","floor2.png","floor3.png","floor4.png","floor5.png","floor6.png","floor7.png","floor8.png","floor9.png","floor10.png"];
	loads(floorTexs,"texture/");
	//壁用テクスチャ
	wallTexs = ["HZN.png","KACHO.png","YJ.png","KMR.png","MJM.png","MUR.png","SKSMS.png","TDN.png"];
	loads(wallTexs,"texture/");
	//モデル
	models = ["SWK/SWK.pmd","ALISON/ALISON.pmd"];
	loads(models,"model/");
	//モーション
	motions = [	"SWK_stand.vmd","SWK_stand_run.vmd","SWK_stand_backWalk.vmd","ALISON_shake.vmd",
				"SWK_title.vmd","SWK_jump.vmd","SWK_juketsu.vmd","SWK_superJump.vmd","SWK_DeathWait.vmd","SWK_DeathBall.vmd","SWK_nomal.vmd"];
	loads(motions,"motion/");
	//背景
	backPics = ["EV1.png","EV2.jpg","EV3.jpg","EV4.jpg"];
	loads(backPics,"picture/");
	//立ち絵
	standPics = ["SWK.png"];
	loads(standPics,"picture/");
}