//汎用テキストセットクラス
function myText(scene,txt,font,size,x,y,colors){
	//ctx情報セット
	this.setCtxInfo = function(){
		var sf = this.sf;
		var ctx = sf.context;
		ctx.beginPath();
		ctx.clearRect(0,0,sf.width,sf.height);
		ctx.font = ""+this.size+"px "+this.font+"";
		this.tWidth = ctx.measureText(this.txt).width;
		sf.width = this.tWidth + sf.width / 20;
		this.onx = (sf.width - this.tWidth) / 2;
		this.ony = sf.height / 1.15;
		ctx.lineWidth = this.size / 10;
	}
	//文字ctxセット
	this.setCtxText = function(){
		var sf = this.sf;
		var ctx = sf.context;
		ctx.strokeStyle = this.colors[2];
		ctx.strokeText(this.txt,this.onx,this.ony);
		this.setGra();
		ctx.fillStyle = this.gra;
		ctx.fillText(this.txt,this.onx,this.ony);
	}
	//土台セット
	this.setUnderCtx = function(c1,c2,c3){
		if(c1 == null) c1 = "rgba(255,255,0,1)";
		if(c2 == null) c2 = "rgba(255,0,255,1)";
		if(c3 == null) c3 = "rgba(255,0,0,1)";
		makeRoundTangle(this.sf,c1,c2,c3);
	}
	//グラデーションカラー作成
	this.setGra = function(){
		this.gra = this.sf.context.createLinearGradient(0,0,0,this.sf.height);
		this.gra.addColorStop(0,this.colors[0]);
		this.gra.addColorStop(1,this.colors[1]);
	}
	//イメージセット
	this.set = function(){
		this.setCtxText();
		this.sp.width = this.sf.width;
		if(this.sp.x == null) this.sp.x = (screenWidth - this.sp.width) / 2;
		if(this.sp.y == null) this.sp.y = (screenHeight - this.sp.height) / 2;
		this.sp.image = this.sf;
	}
	//描画用小道具セット
	this.setSP = function(){
		this.sp = new Sprite(this.size * this.txt.length,this.size);
		this.sp.x = x;
		this.sp.y = y;
		this.sf = new Surface(this.sp.width,this.sp.height);
		this.scene.addChild(this.sp);
		this.setCtxInfo();
	}
	//メイン
	this.main = function(){
		//シーン
		this.scene = scene;
		//テキスト
		this.txt = txt;
		//サイズ
		if(size == null){
			this.size = 40;
		}else{
			this.size = size;
		}
		//フォント
		if(font == null){
			this.font = "Meiryo";
		}else{
			this.font = font;
		}
		//色
		if(colors == null){
			this.colors = [];
		}else{
			this.colors = colors;
		}
		if(this.colors[0] == null) this.colors[0] = "rgba(128,128,128,1)";
		if(this.colors[1] == null) this.colors[1] = "rgba(0,0,0,1)";
		if(this.colors[2] == null) this.colors[2] = "rgba(255,255,255,1)";
		//スプライト
		this.setSP();
	}
	this.main();
}

//時間表示クラス
function setTimer(scene,size,x,y,time){
	//surf内容セット
	this.setCtx = function(){
		var sf = this.SF;
		var ctx = sf.context;
		ctx.clearRect(0,0,sf.width,sf.height);
		ctx.font = ""+this.size+"px myfont";
		var txtwidth = ctx.measureText(this.timeText).width;
		ctx.lineWidth = this.size / 8;
		ctx.strokeStyle = centerGrad(sf,"rgba(0,0,0,1)","rgba(100,100,100,1)");
		ctx.strokeText(this.timeText,(sf.width - txtwidth) / 2,(sf.height + this.size / 1.5) / 2);
		ctx.fillStyle = centerGrad(sf,"rgba(0,60,0,1)","rgba(100,255,100,1)");
		ctx.fillText(this.timeText,(sf.width - txtwidth) / 2,(sf.height + this.size / 1.5) / 2);
	}
	//スプライトのセット
	this.setSP = function(){
		this.refTime();
		this.SP = new Sprite(this.size * this.timeText.length / 1.5, this.size * 1.5);
		this.SP.x = x;
		this.SP.y = y;
		this.SF = new Surface(this.SP.width,this.SP.height);
		this.setCtx(this.SF);
		this.SP.image = this.SF;
		this.scene.addChild(this.SP);
		//アニメ
		var move = 50;
		this.SP.tl.
		scaleTo(0.8,move).
		scaleTo(1,move).
		loop();
	}
	//スプライト更新
	this.refSP = function(){
		this.setCtx();
		this.SP.image = this.SF;
	}
	//更新まとめ
	this.refresh = function(){
		this.refTime();
		this.refSP();
	}
	//時間情報更新
	this.refTime = function(){
		this.min = Math.floor(this.time / 60 / 60);
		this.sec = Math.floor(this.time / 60 % 60);
		this.msec = Math.floor(this.time % 60 * 100 / 60);
		this.timeText = ""+this.min+":"+(("0" + this.sec).slice(-2))+"."+(("0" + this.msec).slice(-2))+"";
	}
	//時間回復処理
	this.repairTime = function(num){
		this.time += num;
		if(this.firstTime < this.time) this.time = this.firstTime;
	}
	//計測開始
	this.start = function(){
		var cls = this;
		this.SP.addEventListener("enterframe",function(){
			cls.time -= 100 / 60;
			//更新してストップ
			if(cls.time <= 0){
				cls.time = 0;
				cls.stop();
			}
			//更新
			cls.refresh();
		});
	}
	//ストップ
	this.stop = function(){
		//更新してストップ
		this.SP.clearEventListener("enterframe");
		this.refresh();
		//経過タイムセット
		this.setCourseTime();
	}
	//経過タイム
	this.setCourseTime = function(){
		this.courseTime = this.firstTime - this.time;
	}
	//メイン
	this.main = function(){
		this.time = time * 60;		//フレーム変換
		this.firstTime = this.time;
		this.courseTime = 0;
		this.scene = scene;
		this.size = size;
		this.setSP();
	}
	this.main();
}

//中間グラデ生成
function centerGrad(surf,c1,c2){
	var gra = surf.context.createLinearGradient(0,0,0,surf.height);
	gra.addColorStop(0,c1);
	gra.addColorStop(0.5,c2);
	gra.addColorStop(1,c1);
	return gra;
}

//モノクロチェックsurf
function monocheck(sf,gr){
	if(gr == null) gr = 19;
	var ctx = sf.context;
	var bX = sf.width / gr; var by = sf.height / gr;
	var tgl = 0;
	for(i=0; i * bX < sf.width; i++){
		for(j=0; j * by < sf.height; j++){
			ctx.beginPath();
			var sX = i * bX; var sY = j * by;
			tgl = !tgl;
			if(tgl){ ctx.fillStyle = "rgba(235,121,136,1)"; }
			else{ ctx.fillStyle = "rgba(242,216,223,1)"; }
			ctx.fillRect(sX,sY,bX,by);
		}
	}
	return ctx;					//値を返す
}

//角丸四角形surf
function makeRoundTangle(surf,color1,color2,color3){
	if(color1 == null) color1 = "rgba(255,255,255,1)";
	if(color2 == null) color2 = "rgba(128,128,128,1)";
	if(color3 == null) color3 = "rgba(0,0,0,1)";
	var ctx = surf.context;
	var rad = 10;
	var line = 3;
	var w = surf.width - line / 2;
	var h = surf.height - line / 2;
    ctx.moveTo(rad,line / 2);
    ctx.arcTo(w, line / 2, w, line / 2 + rad, rad);
    ctx.arcTo(w, h, w - rad, h, rad);
    ctx.arcTo(line / 2, h, line / 2, h - rad, rad);
    ctx.arcTo(line / 2, line / 2, line / 2 + rad, line / 2, rad);
    var x = surf.width / 2;
    var y = surf.height / 2;
    var gra = ctx.createRadialGradient(x,y,rad,x,y,surf.width);
    gra.addColorStop(0,color1);
    gra.addColorStop(1,color2);
    ctx.fillStyle = gra;
    ctx.fill();
    ctx.strokeStyle = color3;
    ctx.lineWidth = line;
    ctx.stroke();
	return ctx;
}

//つかまえたラベル
function tsukamaetaSurf(sf){
	var ctx = sf.context;
	var size = 42;
	var text = "PUSH「Z」…つかまえた";
	makeRoundTangle(sf,"rgba(50,50,50,0.7)","rgba(255,255,255,0.7)");
	ctx.font = ""+size+"px myfont";
	var tWidth = ctx.measureText(text).width;
	ctx.fillStyle = centerGrad(sf,"rgba(255,0,0,1)","rgba(128,0,0,1)");
	ctx.fillText(text,(sf.width - tWidth) / 2,sf.height / 1.375);
	return ctx;
}

//虹色をランダムで返す
function makeRainbowRand(num,alpha){
	if(num == null) num = Math.floor(Math.random() * 7);
	if(alpha == null) alpha = 1;
	var str = [];
	switch(num){
		case 0: str.push(255,0,0); break;
		case 1: str.push(255,180,0); break;
		case 2: str.push(255,255,0); break;
		case 3: str.push(0,153,0); break;
		case 4: str.push(0,0,255); break;
		case 5: str.push(0,0,204); break;
		case 6: str.push(102,0,204); break;
	}
	return "rgba("+str[0]+","+str[1]+","+str[2]+","+alpha+")";
}

//ループBGMを流すクラス
function setLoopBGM(BGMlist){
	//音量初期化
	this.setVolsClear = function(){
		this.vols = [];
		for(var i=0; i<this.list.length; i++){
			this.vols[i] = this.fVol;
		}
	}
	//音量設定
	this.setVol = function(num,vol){
		this.vols[num] = vol;
	}
	//BGMストップ
	this.stop = function(){
		this.scene.clearEventListener("enterframe");
		this.BGM.stop();
		this.id = null;
		this.BGM = null;
	}
	//BGMプレイ
	this.play = function(scene,num){
		if(num == this.stopID){
			//ストップ処理
			this.stop();
			return 0;
		}else if(this.id != null && this.id != num){
			//再生中で別のIDが入った場合は初期化
			this.stop();
		}
		var cancel = 0;
		if(this.id == num) cancel = 1;
		//引数挿入
		if(scene != null) this.scene = scene;
		if(num != null) this.id = num;
		//情報挿入
		this.BGM = game.assets[this.list[this.id]];
		var BGM = this.BGM;
		//ブラウザの再生方式の考慮
		if(BGM.src){
			if(!cancel){
				BGM.play();
				BGM.src.loop = true;
			}
		}else{
			this.scene.addEventListener("enterframe",function(){
				BGM.play();
			});
		}
		BGM.volume = Math.floor(this.vols[this.id] * option.elements[0].num * 0.1 * 100) / 100;
	}
	//メイン
	this.main = function(){
		this.id = null;
		this.list = BGMlist;
		this.fVol = 1;
		this.setVolsClear();
		this.BGM = null;
		this.stopID = 810;
	}
	this.main();
}

//SEを流すクラス
function setSE(SElist){
	//音量初期化
	this.setVolsClear = function(){
		this.vols = [];
		for(var i=0; i<this.list.length; i++){
			this.vols[i] = this.fVol;
		}
	}
	//音量設定
	this.setVol = function(num,vol){
		this.vols[num] = vol;
	}
	//SEプレイ
	this.play = function(num){
		var SE = game.assets[this.list[num]].clone();
		SE.play();
		SE.volume = Math.floor(this.vols[num] * option.elements[1].num * 0.1 * 100) / 100;
	}
	//メイン
	this.main = function(){
		this.list = SElist;
		this.fVol = 1;
		this.setVolsClear();
	}
	this.main();
}

//ランダム値発生
function rand(num1,num2){
	if(num2 == null) num2 = 0;
	return Math.floor(Math.random() * num1 + num2);
}

//汎用ウェイト
function waiting(time,func,entFunc){
	if(time == null) time = 0;
	if(func == null) func = function(){}
	if(entFunc == null) entFunc = function(){}
	var scene = new Scene();
	game.pushScene(scene);
	var ent = new Entity();
	scene.addChild(ent);
	ent.tl.
	delay(time).
	then(function(){
		this.clearEventListener("enterframe");
		this.parentNode.removeChild(this);
		game.popScene();
		func();
	});
	ent.addEventListener("enterframe",function(){
		entFunc();
	});
}
//ダンジョン床
function makeFloorgrids(sf,x,y,texs){
	var ctx = sf.context;
	var w = sf.width / x;
	var h = sf.height / y;
	ctx.lineWidth = w / 10;
	ctx.shadowBlur = w;
	ctx.shadowColor = "rgba(255,255,255,1)";
	ctx.clearRect(0,0,sf.width,sf.height);
	var imgs = [];
	for(var i=0; i<texs.length; i++){
		imgs[i] = game.assets[texs[i]];
	}
	
	for(var i=0; i<x; i++){
		var setx = i * w;
		for(var j=0; j<y; j++){
			var sety = j * h;
			var gra = ctx.createLinearGradient(setx,sety,setx + w,sety + h);
			var color = makeRainbowRand();
			gra.addColorStop(0,color);
			gra.addColorStop(1,"rgba(255,255,255,1)");
			ctx.fillStyle = gra;
			ctx.fillRect(setx,sety,w,h);
			ctx.strokeStyle = "rgba(0,0,0,0.3)";
			ctx.strokeRect(setx,sety,w,h);
			var img = imgs[rand(imgs.length)];
			sf.draw(img,0,0,img.width,img.height,setx,sety,img.width,img.height);
		}
	}
}
//さなトレ式ウィンドウ外形surf
function makeSNTwindowSF(sf,outline){
	var ctx = sf.context;
	var w = sf.width;
	var h = sf.height;
	//塗りつぶし
	ctx.beginPath();
	var col1 = 22;
	var col2 = 160;
	var alpha = 0.8;
	var gra = ctx.createLinearGradient(w / 2,0,w / 2,h);
	gra.addColorStop(0,"rgba("+col1+","+col1+","+col1+","+alpha+")");
	gra.addColorStop(0.4,"rgba("+col2+","+col2+","+col2+","+alpha+")");
	gra.addColorStop(0.5,"rgba("+col2+","+col2+","+col2+","+alpha+")");
	gra.addColorStop(0.6,"rgba("+col2+","+col2+","+col2+","+alpha+")");
	gra.addColorStop(1,"rgba("+col1+","+col1+","+col1+","+alpha+")");
	ctx.fillStyle = gra;
	ctx.fillRect(0,0,w,h);
	ctx.fill();
	//ケロちゃん
	kerox = outline * 1.5;
	keroy = h - 75;
	//顔土台
	var alpha = 0.5;
	ctx.beginPath();
	ctx.fillStyle = "rgba(175,247,148,"+alpha+")";
	ctx.save();
	ctx.translate(kerox,keroy + 25);
	ctx.rotate(45 * Math.PI / 180);
	ctx.scale(2.3,1.1);
	ctx.arc(0,0,15,0,Math.PI*2);
	ctx.restore();
	ctx.setTransform(1,0,0,1,0,0);
	ctx.fill();
	//顔口
	ctx.beginPath();
	ctx.fillStyle = "rgba(255,255,255,"+alpha+")";
	ctx.save();
	ctx.translate(kerox - 7,keroy + 32);
	ctx.rotate(45 * Math.PI / 180);
	ctx.scale(1.5,0.8);
	ctx.arc(0,0,15,0,Math.PI*2);
	ctx.restore();
	ctx.setTransform(1,0,0,1,0,0);
	ctx.fill();
	//左目白目
	ctx.beginPath();
	ctx.fillStyle = "rgba(255,255,255,"+alpha+")";
	ctx.arc(kerox-3,keroy-3,10,0,Math.PI*2);
	ctx.fill();
	//左目黒目
	ctx.beginPath();
	ctx.fillStyle = "rgba(150,150,150,"+alpha+")";
	ctx.arc(kerox-3,keroy-3,7,0,Math.PI*2);
	ctx.fill();
	//右目白目
	ctx.beginPath();
	ctx.fillStyle = "rgba(255,255,255,"+alpha+")";
	ctx.arc(kerox + 28,keroy + 28,10,0,Math.PI*2);
	ctx.fill();
	//右目黒目
	ctx.beginPath();
	ctx.fillStyle = "rgba(150,150,150,"+alpha+")";
	ctx.arc(kerox + 28,keroy + 28,7,0,Math.PI*2);
	ctx.fill();
	//外枠
	ctx.beginPath();
	var gra = ctx.createLinearGradient(0,h / 4,w,h);
	gra.addColorStop(0,"#00b400");
	gra.addColorStop(0.05,"#00b400");
	gra.addColorStop(0.10,"#b0ffb0");
	gra.addColorStop(0.15,"#00b400");
	gra.addColorStop(0.2,"#00b400");
	gra.addColorStop(0.25,"#b0ffb0");
	gra.addColorStop(0.3,"#00b400");
	gra.addColorStop(0.5,"#00b400");
	gra.addColorStop(0.55,"#b0ffb0");
	gra.addColorStop(0.6,"#00b400");
	gra.addColorStop(0.8,"#00b400");
	gra.addColorStop(0.85,"#b0ffb0");
	gra.addColorStop(0.9,"#00b400");
	gra.addColorStop(1,"#00b400");
	ctx.strokeStyle = gra;
	ctx.lineWidth = outline;
	ctx.strokeRect(0,0,w,h);
	//外枠の外枠
	ctx.lineWidth = 1;
	ctx.strokeStyle = "#ffffff";
	ctx.strokeRect(0,0,w,h);
	ctx.strokeStyle = "#555555";
	ctx.strokeRect(outline / 2,outline / 2,w - outline,h - outline);
}

//さなトレ式ウィンドウ生成
function makeSNTwindow(lastFunc){
	//ページクラス
	function onePage(back,img,imgW,imgH,frame,SEnum,color,BGMnum,txts){
		this.back = back;
		this.img = img;
		this.imgW = imgW;
		this.imgH = imgH;
		this.imgFrame = frame;
		this.txts = txts;
		this.BGMnum = BGMnum;
		this.SEnum = SEnum;
		if(color == null){
			this.color = "rgba(255,255,255,1)";
		}else{
			this.color = color;
		}
	}
	//ページ追加
	this.pushPage = function(){
		//引数を配列へ
		var txts = [];
		for(var i=0; i<arguments.length; i++){
			txts[i] = arguments[i];
		}
		//引数から必要な情報を添削
		var back = this.spliseAndSet(txts);
		var img = this.spliseAndSet(txts);
		var imgW = this.spliseAndSet(txts);
		var imgH = this.spliseAndSet(txts);
		var frame = this.spliseAndSet(txts);
		var SEnum = this.spliseAndSet(txts);
		var color = this.spliseAndSet(txts);
		var BGMnum = this.spliseAndSet(txts);
		//新規ページPUSH
		this.pages.push(new onePage(back,img,imgW,imgH,frame,SEnum,color,BGMnum,txts));
	}
	//配列からの抽出
	this.spliseAndSet = function(str){
		var ret = str[0];
		str.splice(0,1);
		return ret;
	}
	//背景セット
	this.setBack = function(){
		this.back = new Sprite(screenWidth,screenHeight);
		var sp = this.back;
		sp.opacity = 0;
		//イメージ切り替え
		var self = this;
		sp.setImg = function(){
			var page = self.pages[self.nowPage];
			//backプロパティに何も無い場合はスルー
			if(page.back != null){
				this.image = game.assets[page.back];
			}
		}
		this.scene.addChild(sp);
		//アニメ
		var time = 5;
		sp.tl.
		fadeTo(1,time);
	}
	//立ち絵セット
	this.setStand = function(){
		this.stand = new function(){}
		var stand = this.stand;
		//現ページ立ち絵セット処理
		var self = this;
		stand.setImg = function(){
			var page = self.pages[self.nowPage];
			//imgプロパティに何も無い場合はスルー
			if(page.img != null){
			var sp = this.sp;
				sp.width = page.imgW;
				sp.height = page.imgH;
				sp.frame = page.imgFrame;
				sp.image = game.assets[page.img];
				sp.x = screenWidth - sp.width;
				sp.y = screenHeight - sp.height;
			}
		}
		//スプライトセット
		stand.sp = new Sprite(screenWidth,screenHeight);
		this.scene.addChild(stand.sp);
	}
	//ウィンドウスプライトセット
	this.setWindow = function(){
		var out = this.outLine;
		this.nowPSP = new Sprite(Math.floor(this.w),Math.floor(this.h));
		var sp = this.nowPSP;
		sp.scale(0,0);
		sp.x = this.x;
		sp.y = this.y;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		makeSNTwindowSF(sf,out);
		sp.image = sf;
		this.scene.addChild(sp);
		var time = 7;
		var self = this;
		sp.tl.
		scaleTo(1.5,0.1,time).
		scaleTo(0.1,1.5,time,eas).
		scaleTo(1,1,time,eas).
		then(function(){
			self.setNextPage();		//次ページ呼び出し
		});
		//しまう処理
		sp.del = function(func){
			var time = 7;
			this.tl.
			scaleTo(0.1,1.5,time,eas).
			scaleTo(1.5,0.1,time,eas).
			scaleTo(0,0,time).
			then(function(){
				this.parentNode.removeChild(this);
				func();
			});
		}
	}
	//スプライトサイズセット
	this.setSPsize = function(){
		this.white = 20;
		this.w = screenWidth - this.white * 2;
		this.h = screenHeight / 2.5;
		this.x = this.white;
		this.y = screenHeight - this.h - this.white;
		this.outLine = 40;
	}
	//メッセージの表示処理
	this.setMesSP = function(){
		this.now = new function(){}
		var now = this.now;
		var win = this.nowPSP;
		now.sp = new Sprite(win.width - this.outLine,win.height - this.outLine);
		now.sp.x = win.x + this.outLine / 2;
		now.sp.y = win.y + this.outLine / 2;
		var sp = now.sp;
		sp.opacity = 0;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		this.setMesSF(sf);
		sp.image = sf;
		this.scene.addChild(sp);
		//次頁の飛ぶタッチ処理
		var self = this;
		var time = 8;
		sp.tl.
		fadeTo(1,time,eas).
		then(function(){
			this.addEventListener("enterframe",function(){
				if(game.input.z){
					this.tl.
					fadeTo(0,time / 2).
					then(function(){
						//音声
						mySubSE.play(8);
						this.parentNode.removeChild(this);
						self.setNextPage();
					});
				}
			});
		});
	}
	//メッセージsurfセット
	this.setMesSF = function(sf){
		var ctx = sf.context;
		var page = this.pages[this.nowPage];
		var txts = page.txts;
		var w = sf.width;
		var h = sf.height / this.allLine;
		ctx.font = ""+h+"px myfont";
		ctx.lineWidth = h / 10;
		for(var i=0; i<txts.length; i++){
			var x = 0;
			var y = i * h + h / 1.2;
			var white = 5;
			ctx.fillStyle = "rgba(0,0,0,0.5)";
			ctx.fillText(txts[i],x + white,y + white,w);
			ctx.strokeStyle = "rgba(0,0,0,1)";
			ctx.strokeText(txts[i],x,y,w);
			ctx.fillStyle = page.color;
			ctx.fillText(txts[i],x,y,w);
		}
	}
	//BGMセット処理
	this.setPageBGM = function(){
		var page = this.pages[this.nowPage];
		if(page.BGMnum != null){
			this.BGMcls.play(this.scene,page.BGMnum);
		}
	}
	//SEセット処理
	this.setPageSE = function(){
		var page = this.pages[this.nowPage];
		if(page.SEnum != null){
			this.SEcls.play(page.SEnum);
		}
	}
	//次のページに行く処理
	this.setNextPage = function(){
		this.nowPage++;
		//そのページが存在するかどうかで分岐
		if(this.pages[this.nowPage] != null){
			this.back.setImg();			//背景切り替え
			this.stand.setImg();		//立ち絵切り替え
			this.setPageBGM();			//BGMセット処理
			this.setPageSE();			//SEセット処理
			this.setMesSP();
		}else{
			//ウィンドウを閉じてから終了
			var self = this;
			this.nowPSP.del(function(){
				game.popScene();
				self.lastFunc();
			});
		}
	}
	//描画開始
	this.start = function(){
		this.setScene();		//シーンセット
		this.setBack();			//背景呼び出し
		this.setStand();		//立ち絵呼び出し
		this.setWindow();		//ウィンドウ呼び出し
	}
	//シーンセット
	this.setScene = function(){
		this.scene = new Scene();
		game.pushScene(this.scene);
	}
	//BGMクラスセット
	this.setBGMclass = function(BGMclass){
		this.BGMcls = BGMclass;
	}
	//SEクラスセット
	this.setSEclass = function(SEclass){
		this.SEcls = SEclass;
	}
	//メイン
	this.main = function(){
		this.lastFunc = lastFunc;
		this.pages = [];
		this.now = null;
		this.nowPage = -1;
		this.allLine = 4;
		this.setSPsize();
	}
	this.main();
}

//テキスト用surface
function makeSurfText(surf,size,text,c1,c2,x,y){
	if(x == null) x = 0;
	if(y == null) y = 0;
	var ctx = surf.context;
	ctx.font = ""+size+"px Meiryo";
	ctx.lineWidth = size / 8;
	var line = ctx.lineWidth;
	ctx.strokeStyle = "rgba(0,0,0,0.6)";
	ctx.strokeText(text,line / 2 + x + 4,size + y + 4,surf.width - line);
	ctx.strokeStyle = "rgba(0,0,0,1)";
	ctx.strokeText(text,line / 2 + x,size + y,surf.width - line);
	var gra = ctx.createLinearGradient(0,0,0,surf.height);
	gra.addColorStop(1,c1);
	gra.addColorStop(0,c2);
	ctx.fillStyle = gra;
	ctx.fillText(text,line / 2 + x,size + y,surf.width - line);
}

//入力フォームセット
function setInputForm(scene,x,y,w,h,length,color,clearName,lastFunc){
	//入力欄セット
	this.setForm = function(){
		this.form = new Entity();
		var ent = this.form;
		ent.width = this.w;
		ent.height = this.h;
		ent.backgroundColor = this.color;
		ent.x = this.x;
		ent.y = this.y;
		ent._element = document.createElement("input");
		var ele = ent._element;
		ele.setAttribute("name","myInput");
		ele.setAttribute("type","text");
		ele.setAttribute("maxlength",""+this.length+"");
		ele.value = this.clearName;
		this.scene.addChild(ent);
		ent._element.focus();
		//名前
		this.lab = new Label(ent.value);
		var lab = this.lab;
		lab.color = "rgba(0,50,0,1)";
		lab.width = screenWidth;
		lab.font = "100px myfont";
		lab.x = (screenWidth - lab._boundWidth) / 2;
		lab.y = (screenHeight - lab._boundHeight) / 2;
		this.scene.addChild(lab);
		//名前大きく表示
		lab.addEventListener("enterframe",function(){
			this.text = ele.value;
			this.x = (screenWidth - this._boundWidth) / 2;
		});
	}
	//シーンを自動生成した場合の処理
	this.auto = function(){
		var self = this;
		var time = 10;
		//背景セット
		this.back = new Sprite(screenWidth,screenHeight);
		var sp = this.back;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		monocheck(sf);
		//遅延
		var ent = new Entity();
		this.scene.addChild(ent);
		ent.tl.
		delay(time).
		then(function(){
			self.scene.addEventListener("enterframe",function(){
				if(game.input.enter){
					game.popScene();
					self.lastFunc();
				}
			});
		});
	}
	//メイン
	this.main = function(){
		if(lastFunc != null) this.lastFunc = lastFunc;
		if(scene == null){
			this.scene = new Scene();
			game.pushScene(this.scene);
			this.auto();
		}else{
			this.scene = scene;
		}
		if(w == null){
			this.w = 120;
		}else{
			this.w = w;
		}
		if(h == null){
			this.h = 15;
		}else{
			this.h = h;
		}
		if(x == null){
			this.x = (screenWidth - this.w) / 2;
		}else{
			this.x = x;
		}
		if(y == null){
			this.y = (screenHeight - this.h) / 2;
		}else{
			this.y = y;
		}
		if(length == null){
			this.length = 10;
		}else{
			this.length = length;
		}
		if(color == null){
			this.color = "rgba(255,255,255,0.5)";
		}else{
			this.color = color;
		}
		if(clearName == null){
			this.clearName = "noname";
		}else{
			this.clearName = clearName;
		}
		this.setForm();
	}
	this.main();
}


//新規ローディングシーン
function makeLoadScene(){
	var scene = game.loadingScene;
	scene.backgroundColor = "rgba(50,255,0,0.5)";
	//myfontローディング
	var label = new Label("load");
	label.font = "60px myfont";
	label.opacity = 0;
	scene.addChild(label);
	//+⌒o⌒+
	for(var i=0; i<10; i++){
		var label = new Label("+⌒o⌒+");
		label.color = makeRainbowRand();
		label.font = "60px Meiryo";
		label.width = 1000;
		label.x = rand(screenWidth) - label._boundWidth / 2;
		label.y = rand(screenHeight) - label._boundHeight / 2;
		scene.addChild(label);
		label.count = 0;
		label.addEventListener("enterframe",function(){
			this.count++;
			if(this.count >= 20){
				this.count = 0;
				this.tl.
				fadeTo(0,5).
				then(function(){
					this.x = rand(screenWidth) - label._boundWidth / 2;
					this.y = rand(screenHeight) - label._boundHeight / 2;
					this.color = makeRainbowRand();
				}).
				fadeTo(1,5);
			}
		});
	}
	//文字
	var label = new Label("蛙は口ゆえ蛇に呑まるる");
	label.color = "rgba(255,255,255,1)";
	label.font = "60px Meiryo";
	label.width = 1000;
	label.x = (screenWidth - label._boundWidth) / 2;
	label.y = 50;
	scene.addChild(label);
	//文字
	var label = new Label("Now Loading...");
	label.color = "rgba(0,0,0,1)";
	label.font = "60px Meiryo";
	label.width = 1000;
	label.x = screenWidth - label._boundWidth;
	label.y = screenHeight - 100;;
	scene.addChild(label);
	var move = 30;
	var time = 3;
	label.tl.
	moveBy(0,-move,time,eas).moveBy(0,move,time,eas).
	moveBy(0,-move,time,eas).moveBy(0,move,time,eas).
	delay(time * 8).
	loop();
}

//2Dシーンのオールクリア
function scene2DallClear(){
	var scene = game.currentScene;
	scene.clearEventListener("enterframe");
	var str = scene.childNodes;
	for(var i=0; i<str.length; i++){
		str[i].clearEventListener("enterframe");
		scene.removeChild(str[i]);
	}
	game.popScene();
}

//Flash
function makeFlash(scene,color,opa,time){
	var sp = new Sprite(screenWidth,screenHeight);
	sp.opacity = 0;
	var sf = new Surface(sp.width,sp.height);
	var ctx = sf.context;
	ctx.fillStyle = color;
	ctx.fillRect(0,0,sf.width,sf.height);
	sp.image = sf;
	scene.addChild(sp);
	sp.tl.
	fadeTo(opa,time / 2,eas).
	fadeTo(0,time / 2,eas).
	then(function(){
		this.parentNode.removeChild(this);
	});
}

//画面往復ピクチャ
function makeLoopPicture(scene,img,w,h,speed,allFrame,tgl){
	this.sp = new Sprite(w,h);
	var sp = this.sp;
	sp.x = rand(screenWidth - sp.width);
	sp.y = rand(screenHeight - sp.height);
	sp.scale(-tgl,1);
	sp.allFrame = allFrame;
	scene.addChild(sp);
	sp.image = game.assets[img];
	sp.tgl = tgl;
	sp.speed = speed;
	sp.opacity = 0;
	sp.tl.
	fadeTo(1,10).
	then(function(){
		this.tl.
		delay(2).
		then(function(){
			this.x += this.speed * this.tgl;
			if(this.x <= -this.width || this.x >= screenWidth){
				this.tgl *= -1;
				this.scale(-1,1);
				this.y = rand(screenHeight - this.height);
			}
			this.frame++;
			if(this.frame >= this.allFrame){
				this.frame = 0;
			}
		}).
		loop();
	});
}

//利用素材クラス
function showMaterialScene(txts,size){
	//テキストセット
	this.setTxts = function(){
		this.txtsSP = new Sprite(Math.floor(screenWidth),Math.floor(this.size * this.txts.length));
		var sp = this.txtsSP;
		sp.x = -screenWidth / 8;
		sp.y = 0;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		ctx.fillStyle = "rgba(128,255,128,1)";
		ctx.strokeStyle = "rgba(0,0,0,1)";
		ctx.font = ""+this.size+"px myfont";
		ctx.lineWidth = this.size / 8;
		for(var i=0; i<this.txts.length; i++){
			var tWidth = ctx.measureText(this.txts[i]).width;
			var x = (sf.width - tWidth) / 2;
			var y = this.size + i * this.size;
			ctx.strokeText(this.txts[i],x,y,sf.width);
			ctx.fillText(this.txts[i],x,y,sf.width);
		}
		sp.image = sf;
		this.scene.addChild(sp);
		//入力処理追加
		sp.speed = 5;
		sp.addEventListener("enterframe",function(){
			if(game.input.down){
				this.moving(-1);
			}else
			if(game.input.up){
				this.moving(1);
			}else
			if(game.input.z){
				//シーン消去
				scene2DallClear(this.parentNode);
				title();
			}
		});
		var self = this;
		sp.max = 0;
		sp.min = -(sp.height - screenHeight + this.size);
		this.state = 0;
		sp.moving = function(num){
			var speed = this.speed;
			if(game.input.x) speed *= 4;
			var next = num * speed + this.y;
			if(next < sp.max && next > sp.min){
				sp.y = next;
				self.state = 0;
			}else if(next >= sp.max){
				self.state = 1;
			}else if(next <= sp.min){
				self.state = 2;
			}
		}
		sp.moving(0);			//初期化
	}
	//上下表示
	this.setUpDown = function(){		
		this.makeCursor = function(txt,x,y){
			var sp = new Sprite(this.size * 2,this.size * 2);
			sp.x = x;
			sp.y = y;
			sp.opacity = 0;
			sp.sf = new Surface(sp.width,sp.height);
			var sf = sp.sf;
			var ctx = sf.context;
			makeRoundTangle(sf,"rgba(50,128,50,0.7)","rgba(128,255,128,0.7)","rgba(255,255,255,0.7)");
			ctx.font = ""+this.size * 2+"px myfont";
			var tWidth = ctx.measureText(txt).width;
			ctx.fillStyle = "rgba(255,255,0,1)";
			ctx.fillText(txt,(sf.width - tWidth) / 2,this.size * 2 / 1.08);
			sp.image = sf;
			this.scene.addChild(sp);
			var time = 20;
			sp.tl.
			scaleTo(0.9,0.9,time,eas).
			scaleTo(1,1,time,eas).
			loop();
			return sp;
		}
		//↑
		this.upSP = this.makeCursor("↑",this.size / 4,this.size / 2);
		var sp = this.upSP;
		var self = this;
		sp.addEventListener("enterframe",function(){
			if(self.state == 1){
				this.opacity = 0;
			}else{
				this.opacity = 1;
			}
		});
		//↓
		this.upSP = this.makeCursor("↓",this.size / 4,screenHeight - this.size / 2 - this.size * 2);
		var sp = this.upSP;
		var self = this;
		sp.addEventListener("enterframe",function(){
			if(self.state == 2){
				this.opacity = 0;
			}else{
				this.opacity = 1;
			}
		});
	}
	//タイトル
	this.title = function(){
		this.titleSP = new myText(this.scene,"お惣菜","myfont",80,null,null);
		var text = this.titleSP;
		var sp = text.sp;
		sp.opacity = 0;
		text.colors = ["rgba(0,0,0,1)","rgba(128,128,128,1)","rgba(0,255,0,1)"];
		sp.tl.fadeTo(1,20,eas).
		then(function(){
			var time = 20;
			this.tl.
			scaleTo(0.9,0.9,time,eas).
			scaleTo(1,1,time,eas).
			loop();
		});
		text.set();
		var white = screenWidth / 20;
		sp.x = screenWidth - sp.width - white;
		sp.y = white;
	}
	//説明テキスト
	this.setTutoText = function(){
		//汎用
		this.setSubText = function(txt,x,y){
			var text = new myText(this.scene,txt,"myfont",40,null,null);
			var sp = text.sp;
			sp.opacity = 0;
			text.colors = ["rgba(0,0,0,1)","rgba(128,128,128,1)","rgba(255,255,255,1)"];
			sp.tl.fadeTo(1,10,eas);
			text.set();
			var white = screenWidth / 20;
			sp.x = x;
			sp.y = y;
			return text;
		}
		var t1SP = this.setSubText("Zキーでタイトルへ",null,null);
		var sp = t1SP.sp;
		sp.x = screenWidth - sp.width;
		sp.y = screenHeight - sp.height * 2;
		var t2SP = this.setSubText("Xキーでスクロール加速",sp.x,sp.y + sp.height);
		var sp2 = t2SP.sp;
		sp2.x = screenWidth - sp2.width;
		sp2.y = sp.y + sp.height;
	}
	//モリヤステップSWK様
	this.setStepSP = function(){
		var allFrame = 6;
		var img = game.assets[pics[10]];
		this.stepSP = new Sprite(200,250);
		var sp = this.stepSP;
		sp.image = img;
		sp.x = screenWidth - sp.width * 1.5;
		sp.y = (screenHeight - sp.height) / 2;
		sp.opacity = 0;
		sp.tl.
		fadeTo(1,10).
		then(function(){
			this.addEventListener("enterframe",function(){
				this.frame+=0.2;
				if(this.frame >= allFrame){
					this.frame = 0;
				}
			});
		});
		this.scene.addChild(sp);
	}
	//描画
	this.show = function(){
		this.sceneMake();		//シーン生成
		this.setBack();			//背景生成
		this.setTxts();			//テキストセット
		this.title();			//タイトルセット
		this.setUpDown();		//上下SP
		this.setTutoText();		//解説テキスト
		this.setStepSP();		//モリヤステップSWK様
	}
	//背景生成
	this.setBack = function(){
		this.back = new Sprite(screenWidth,screenHeight);
		var sp = this.back;
		sp.image = game.assets[pics[7]];
		sp.opacity = 0.5;
		this.scene.addChild(sp);
	}
	//シーン生成
	this.sceneMake = function(){
		this.scene = new Scene();
		game.pushScene(this.scene);
	}
	//メイン
	this.main = function(){
		this.txts = txts;
		this.size = size;
		this.show();
	}
	this.main();
}

//現場監督
function kantoku(scene,seClass){
	//スプライトセット
	this.setSP = function(){
		var img = game.assets[pics[9]];
		var scale = rand(12,3);
		scale = scale / 10;
		var sf = new Surface(Math.floor(img.width * scale),Math.floor(img.height * scale));
		sf.draw(img,0,0,img.width,img.height,0,0,sf.width,sf.height);
		this.sp = new Sprite(sf.width,sf.height);
		this.sp.image = sf;
		this.sp.x = rand(screenWidth - this.sp.width);
		this.sp.y = rand(screenHeight - this.sp.height);
		this.scene.addChild(this.sp);
		this.sp.moving = 0;
		this.sp.talkCount = 0;
		this.sp.sclX = 1;
		this.sp.scale(0,0);
		//アニメ
		this.sp.tl.
		scaleTo(1,1,20,eas).then(function(){
			this.addEventListener("enterframe",function(){
				if(rand(1) == 0 && this.moving == 0){
					this.moving = 1;
					var move; var ang; var moveX; var moveY; var time;
					while(1){
						move = rand(100,50);
						ang = rand(360) * Math.PI / 180;
						moveX = this.x + Math.sin(ang) * move;
						moveY = this.y + Math.cos(ang) * move;
						time = rand(40,20);
						if(moveX >= 0 && moveX <= screenWidth - this.width && moveY >= 0 && moveY <= screenHeight - this.height) break;
					}
					if((this.x <= moveX && this.scaleX > 0) || (this.x > moveX && this.scaleX < 0)){
						this.scale(-1,1);
						this.sclX *= -1;
					}
					var move = 30;
					var jTime = rand(3,3);
					this.tl.
					moveTo(moveX,moveY,time,eas).
					then(function(){
						kantokuSE.play(rand(kantokuSE.list.length));
					}).
					moveBy(0,-move,jTime).moveBy(0,move,jTime).
					moveBy(0,-move,jTime).moveBy(0,move,jTime).
					scaleTo(0.8 * this.sclX,1.2,time / 8,eas).scaleTo(1 * this.sclX,1,time / 8,eas).
					scaleTo(1.2 * this.sclX,0.8,time / 8,eas).scaleTo(1 * this.sclX,1,time / 8,eas).
					then(function(){
						this.moving = 0;
					});
				}
			});
		});
	}
	//表示
	this.show = function(){
		this.setSP();				//スプライトセット
	}
	//メイン
	this.main = function(){
		this.seClass = seClass;
		this.scene = scene;
		this.show();
	}
	this.main();
}

//ダイアログ
function makeDialog(size,func){
	//カーソルセット
	this.setCursor = function(){
		this.curSP = new Sprite(this.size / 1.3,this.size / 2.5);
		var sp = this.curSP;
		sp.opacity = 0;
		var self = this;
		sp.moving = 0;
		sp.setXY = function(){
			var w = self.undSP.width / 4 - this.width / 2 + (self.curNum-1) * self.undSP.width / 2;
			var x = self.undSP.x + w;
			var y = self.undSP.y + (self.undSP.height - this.height) / 2;
			this.moving = 1;
			this.tl.
			moveTo(x,y,5,eas).
			then(function(){
				this.moving = 0;
			});
		}
		sp.setXY();
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		makeRoundTangle(sf,"rgba(0,0,0,0)","rgba(255,255,255,0)","rgba(255,255,255,1)");
		sp.image = sf;
		this.scene.addChild(sp);
		sp.tl.
		fadeTo(1,5).
		then(function(){
			//キー処理
			sp.addEventListener("enterframe",function(){
				if(this.moving == 0){
					if(game.input.right || game.input.left){
						if(self.curNum == 1){
							self.curNum = 2;
						}else{
							self.curNum = 1;
						}
						this.setXY();
					}else if(game.input.z){
						this.tl.
						fadeTo(0,5).
						then(function(){
							game.popScene();
							if(self.curNum == 1){
								self.func();
							}
						});
						self.undSP.tl.
						fadeTo(0,5);
					}
				}
			});
		});
	}
	//土台セット
	this.setUnder = function(){
		this.undSP = new Sprite(this.size * 2,this.size);
		var sp = this.undSP;
		sp.x = (screenWidth - sp.width) / 2;
		sp.y = (screenHeight - sp.height) / 2;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		makeRoundTangle(sf,"rgba(0,0,0,1)","rgba(255,255,255,1)","rgba(255,255,255,1)");
		var h = this.size / 6;
		ctx.font = ""+h+"px myfont";
		var txt = "ゲームを初期化しますか？";
		var tWidth = ctx.measureText(txt).width;
		ctx.fillStyle = "rgba(255,255,255,1)";
		ctx.fillText(txt,(sf.width - tWidth) / 2,h);
		ctx.font = ""+h * 2+"px myfont";
		ctx.fillStyle = "rgba(255,0,0,1)";
		var txt = "はい";
		var tWidth = ctx.measureText(txt).width;
		ctx.fillText(txt,sf.width / 4 - tWidth / 2,sf.height / 2 - h / 2 + h * 1.2);
		ctx.fillStyle = "rgba(0,255,0,1)";
		var txt = "いいえ";
		var tWidth = ctx.measureText(txt).width;
		ctx.fillText(txt,(sf.width / 4) * 3 - tWidth / 2,sf.height / 2 - h / 2 + h * 1.2);
		sp.image = sf;
		this.scene.addChild(sp);
		var time = 10;
		sp.scale(0,0);
		var self = this;
		sp.tl.
		fadeTo(1,time,eas).
		scaleTo(1,1,time,eas).
		then(function(){
			self.setCursor();
		});
	}
	//メイン
	this.main = function(){
		this.size = size;
		this.scene = new Scene;
		game.pushScene(this.scene);
		this.func = func;
		this.curNum = 2;
		this.setUnder();
	}
	this.main();
}