enchant();
window.onload = function(){
	gameSet();
}

function setGame(){
	//2D空間
	space2D();
	//3D空間
	space3D();
}

function space3D(){
	scene3D.backgroundColor = [0.5,0.5,1,0.7];
	//ゲーム初期化用クラス
	var Clear = new gameClear(scene3D);
	//repairタイムセット
	var rTime = new repairTime(scene2D,250,50);
	//ライト
	var light = setLight(scene3D,0,100,100,1,1,1);
	//カメラ
	var camera = setCamera(scene3D,0,600,600,0,10,0);
	//迷路
	var num = nowDif.types[nowDif.dif].num;
	var rab = new makeLaby(scene3D,scene2D,num,num,wallTexs);
	//床
	var floor = makeFloor(scene3D,rab.width,rab.height,-2);
	floor.x = rab.width - rab.size; floor.z = rab.height - rab.size;
	//SWK様モデル
	var SWK = setModel(scene3D,rand(4) * 90,0,rab.startX,0,rab.startY,0,1);
	SWK.canMove = 0;
	scene3D.addChild(SWK);
	//カメラはSWK様の後ろ
	SWK.backCameraEnter = function(){
		SWK.backCamera(camera,120);
	}
	SWK.addEventListener("enterframe",SWK.backCameraEnter);
	//スタートアニメ
	startAnime(function(){
		//SWK様残りスプライト
		SWK.canMove = 1;
		scene3D.addChild(SWK.touchSP);
		SWK.setTalk(scene2D,20);			//会話スプライトセット
		//タイマースタート
		timer.start();
		//ヤク中モデル
		var KZ = setKZ(scene3D,rab);
		scene3D.addChild(KZ);
		//SWK様の会話対象に
		SWK.setTalkNode(KZ,function(){
			clearGame();
		});
		//迷路との衝突判定セット
		SWK.setTouch(rab);
		rab.setTouch(SWK);
		//マップにSWK様位置セット
		rab.setNodePos(SWK,1);
		//マップにヤク中位置セット
		rab.setNodePos(KZ);
		//アイテム情報セット
		var itemInfos = new setItemInfos();
		itemInfos.KZ = KZ;
		itemInfos.rTime = rTime;
		itemInfos.timer = timer;
		itemInfos.SWK = SWK;
		itemInfos.set();
		rab.itemTypes = itemInfos.str;
		//ステータス情報セット
		var str = itemInfos.str;
		myStates = new states(scene2D,30,10,null,null);
		myStates.setST("Speed",SWK.speedAtend,SWK.speedAtendMax,str[2].color);
		myStates.setST("Paralysis",KZ.waitAtend,KZ.waitAtendMax,str[0].color);
		myStates.setST("Range",SWK.touchTalk.radAtend,SWK.touchTalk.radAtendMax,str[3].color);
		myStates.set();
		myStates.sp.addEventListener("enterframe",function(){
			var str = myStates.STs;
			var flag = 0;
			set(str[0],SWK.speedAtend);
			set(str[1],KZ.waitAtend);
			set(str[2],SWK.touchTalk.radAtend);
			if(flag) myStates.ref();
			
			function set(st,num){
				if(st.num != num){
					st.num = num;
					flag = 1;
				}
			}
		});
		//スコアセット
		var sp = myStates.sp;
		var size = 30;
		var SCO = new makeScore(scene2D,0,size,sp.x,sp.y - size * 2);
		itemInfos.SCO = SCO;
		//迷路のアイテムにタッチするノードセット(SWK様)
		rab.setItemTouchNode(SWK.touchTalk);
		//アイテムランダムセット
		rab.setItemRand();
		//固定オブジェクト情報セット
		var objInfos = new objectInfos();
		objInfos.SWK = SWK;
		objInfos.rab = rab;
		objInfos.KZ = KZ;
		objInfos.sta = myStates;
		objInfos.rTime = rTime;
		objInfos.timer = timer;
		objInfos.set();
		rab.objTypes = objInfos.str;
		rab.setObjTouchNode(SWK);
		rab.setObjAll();
		//迷路の描画範囲の設定
		var dist = option.elements[2].num * 150;
		rab.setSpriteDist(SWK,dist);
		//クリア時に消去するスプライトセット
		Clear.set(KZ);
		Clear.set(SWK.touchSP);
		Clear.set(SWK);
		Clear.set(SWK.touchTalk);
		Clear.set(floor);
		for(var i=0; i<rab.SPs.length; i++){
			for(var j=0; j<rab.SPs[i].length; j++){
				Clear.set(rab.SPs[i][j]);
			}
		}
		for(var i=0; i<rab.objStr.length; i++){
			Clear.set(rab.objStr[i].sp);
		}
		//ゲームオーバー呼び出し処理追加
		//GAME OVER
		function gameoverCall(){
			scene2D.clearEventListener("enterframe");
			gameOver();
		}
		var gameOverKeyCount = 0;
		var gameOverCountMax = 60;
		var gameOversStop = 0;
		scene2D.addEventListener("enterframe",function(){
			if(gameOversStop == 0){
				if(timer.time == 0){
					 gameoverCall();
				}else{
					//Gキー長押しでも終了
					if(game.input.g){
						gameOverKeyCount++;
						if(gameOverCountMax <= gameOverKeyCount) gameoverCall();
					}else{
						gameOverKeyCount = 0;
					}
				}
			}
		});
		/*
		test

		var ent = new Entity();
		scene2D.addChild(ent);
		ent.tl.
		delay(30).
		then(function(){
			clearGame();
		});
		*/

		//ゲームストップ
		function stopGame(){
			gameOversStop = 1;												//ゲームオーバー呼び出しを止める
			timer.stop();													//タイマー止める
			rab.setItemRand_del();											//アイテム消去
			Clear.clear2Dscene();											//2Dシーン削除
			//SWK様停止
			SWK.canMove = 0;
			SWK.removeEventListener("enterframe",SWK.backCameraEnter);
			SWK.removeEventListener("enterframe",SWK.rotating180);
			SWK.touchTalk.removeEventListener("enterframe",SWK.touchTalk.touchTalkingFlash);
			//Alison停止
			KZ.clearEventListener("enterframe");
			KZ.scaleX = 1; KZ.scaleY = 1; KZ.scaleZ = 1;
		}
		//クリア時処理
		function clearGame(){
			var time = timer.time;
			timer.setCourseTime();
			var courseTime = timer.courseTime;
			var tText = timer.timeText;
			var score = SCO.score;
			var allItem = itemInfos.allPick;
			stopGame();
			//全てのブロックを消す(オブジェクトも)
			rab.allBlockFadeOut(function(){
				//SWK様クリアアニメ
				SWK.allClearAnime(camera,function(){
					Clear.clear();													//クリア処理
					scene3D.backgroundColor = [0,0,0,1];
					//リザルト
					var result = new makeResult(time,courseTime,tText,score,allItem,function(){
						scene3D.backgroundColor = [0,0,0,1];
						//ランキング閲覧
						setRankingView();
						//ランキングセーブ
						var str = Rankings.setSaveString();
						localStorage.setItem("ranking",JSON.stringify(str));
					},Rankings,nowDif);
				});
			});
		}
		//ゲームオーバー時処理
		function gameOver(){
			//BGM再生
			myBGM.stop();
			//SE再生
			mySWKSE.play(5);
			stopGame();
			var scene = new Scene();
			game.pushScene(scene);
			var sub = new myText(scene,"GAMEOVER・・・","myfont",180,null,null);
			sub.sp.opacity = 0;
			sub.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
			var move = 200;
			var time = 20;
			sub.sp.tl.
			fadeTo(1,time / 4,eas).and().
			moveBy(0,screenHeight,time / 4).
			moveBy(0,-move,time / 4,eas).moveBy(0,move,time / 4,eas).
			moveBy(0,-move / 2,time / 4,eas).moveBy(0,move / 2,time / 4,eas).
			moveBy(0,-move / 4,time / 4,eas).moveBy(0,move / 4,time / 4,eas).
			moveBy(0,-move / 8,time / 4,eas).moveBy(0,move / 8,time / 4,eas).
			delay(time).
			then(function(){
				Clear.clear();													//クリア処理
				scene3D.backgroundColor = [0,0,0,1];
				title();
			});
			sub.set();
			var sp = sub.sp;
			sp.y = -(screenHeight + sp.height) / 2;
			sp.x = (screenWidth - sp.width) / 2;
		}
	});
}

//2Dシーン
function space2D(){
	scene2D = new Scene();
	scene2D.backgroundColor = "rgba(0,0,0,0)";
	game.pushScene(scene2D);
	//BGM再生
	myBGM.play(scene2D,0);
	//タイマー
	timer = new setTimer(scene2D,90,-100,-100,nowDif.types[nowDif.dif].time);
	timer.SP.x = screenWidth - timer.SP.width;
	timer.SP.y = 0;
}

//3D用

//ヤク中モデルセット
function setKZ(scene3D,rab){
	var sp = setModel(scene3D,rand(360),1,rab.goalX,0,rab.goalY,3,null,1);
	//ウェイト処理計算
	sp.wait = 10;
	sp.waitAtend = 0;
	sp.waitAtendMax = 110;
	//加味ウェイトセット処理
	sp.trueWaitSet = function(){
		this.trueWait = this.wait + this.waitAtend;
	}
	sp.trueWaitSet();
	sp.repairWait = function(){
		if(this.waitAtend < this.waitAtendMax){
			this.waitAtend += this.waitAtendMax / 10;
		}else{
			this.waitAtend = this.waitAtendMax;
		}
		this.trueWaitSet();
	}
	//スペシャルアップ用
	sp.spUP = 0;
	//定期的に移動
	sp.count = 0;
	sp.addEventListener("enterframe",function(){
		this.count++;
		var point = this.trueWait + (this.spUP * this.waitAtendMax / 10);				//スペシャルアップの考慮
		if(this.count >= point){
			var num = 0.33;
			this.scaleX -= num; this.scaleY -= num; this.scaleZ -= num;
			if(this.scaleX < 0.1){
				this.scaleX = 1; this.scaleY = 1; this.scaleZ = 1;
				this.count = 0;
				rab.setGoalP();
				sp.x = rab.goalX;
				sp.z = rab.goalY;
			}
		}
		this.rotateYaw(0.1);
	});
	//返却
	return sp;
}
//床生成
function makeFloor(scene,w,h,y){
	var floor = new Plane(w,h);
	var surf = new Surface(w,h);
	var ctx = surf.context;
	var setx = nowDif.types[nowDif.dif].num;
	var sety = setx;
	makeFloorgrids(surf,setx,sety,floorTexs);
	surf._element.src = Math.random();
	floor.mesh.texture.src = surf;
	floor.x = 0; floor.y = y; floor.z = 0;
	mat4.rotateX(floor.rotation, -90 * Math.PI / 180);
	scene.addChild(floor);
	return floor;
}
//ライト生成
function setLight(scene,x,y,z,c1,c2,c3){
	var lgt = new DirectionalLight();
	lgt.directionX = x; lgt.directionY = y; lgt.directionZ = z;
	lgt.color = [c1,c2,c3];
	lgt.scene = scene;
	lgt.scene.setDirectionalLight(lgt);
	return lgt;
}
//カメラ生成
function setCamera(scene,x,y,z,cx,cy,cz){
	var cmr = new Camera3D();
	cmr.x = x; cmr.y = y; cmr.z = z;
	cmr.centerX = cx; cmr.centerY = cy; cmr.centerZ = cz;
	cmr.scene = scene;
	cmr.scene.setCamera(cmr);
	return cmr;
}

//アイテム情報セットクラス
function setItemInfos(){
	//取得時スコア計算
	this.setSco = function(cls){
		this.timer.setCourseTime();
		var sco = Math.floor(cls.pickNum * Math.floor(this.timer.courseTime / 60) + 1);
		this.SCO.ref(sco);
		//ついでに総取得数も加算
		this.allPick++;
	}
	//セット
	this.set = function(){
		var str = this.str;
		var cls = this;
		str.push(new itemInfo(str.length,"RIM",itemTexs[0],0,"rgba(255,0,0,1)",function(){
			cls.KZ.repairWait();
			cls.setSco(this);
		},"ヤク中の休憩時間が伸びたわっ！"));
		str.push(new itemInfo(str.length,"UDK",itemTexs[1],1,"rgba(255,255,0,1)",function(){
			cls.timer.repairTime(rand(cls.rTime.randNum,cls.rTime.fNum));
			cls.setSco(this);
		},"追加で待つわっ！"));
		str.push(new itemInfo(str.length,"ALC",itemTexs[2],2,"rgba(255,0,255,1)",function(){
			cls.SWK.speedAtending();
			cls.setSco(this);
		},"移動速度アップだわっ！"));
		str.push(new itemInfo(str.length,"SIK",itemTexs[3],3,"rgba(255,128,0,1)",function(){
			cls.SWK.touchTalk.pointAtending();
			cls.setSco(this);
		},"タッチ可能範囲が増えたわっ！"));
	}
	//メイン
	this.main = function(){
		this.str = [];
		this.allPick = 0;
	}
	this.main();
}

//固定オブジェクト情報セット
function objectInfos(){
	//セット処理
	this.set = function(){
		var str = this.str;
		var cls = this;
		
		//ID1(ワープ)
		str.push(new setObjInfo(str.length,objTexs[str.length],str.length,function(my){
			cls.SWK.warp(my.warpX,my.warpY);
		},"rgba(128,255,128,1)","warp",function(my){
			//追加関数
			cls.rab.setWarpP(my);
		},"対になる場所へ飛んできたわっ！","UTH"));
		
		//ID2(千里眼)
		str.push(new setObjInfo(str.length,objTexs[str.length],str.length,function(){
			cls.rab.setVoyance(1);
		},"rgba(255,0,255,1)","voyance",function(){
		},"アイテム位置が見えるし太いZE☆","PCR"));
			
		//ID3(Paralysis増加)
		str.push(new setObjInfo(str.length,objTexs[str.length],str.length,function(){
			cls.sta.setSPup(cls.KZ,1,3,180);
		},"rgba(128,0,255,1)","addTime",function(){
		},"⑨番茶でもっと休憩だわっ！","CRN"));
			
		//ID4(時間回復増加)
		str.push(new setObjInfo(str.length,objTexs[str.length],str.length,function(){
			cls.rTime.setGauge(80);
		},"rgba(255,255,128,1)","addPar",function(){
		},"UDKのお手伝いだわっ！","KAKM"));
		//ID5(タッチ範囲増加)
		str.push(new setObjInfo(str.length,objTexs[str.length],str.length,function(){
			cls.sta.setSPup(cls.SWK.touchTalk,2,3,280,function(){
				cls.SWK.touchTalk.truePointSet();
			});
		},"rgba(0,128,0,1)","addRan",function(){
		},"答えられるようにしてくれたわっ！","YUK"));
		//ID5(スピード増加)
		str.push(new setObjInfo(str.length,objTexs[str.length],str.length,function(){
			cls.sta.setSPup(cls.SWK,0,3,320,function(){
				cls.SWK.trueSpeedSet();
			});
		},"rgba(242,216,223,1)","addSpd",function(){
		},"鳥の知り合いがいた！","MSTA"));
	}
	//メイン
	this.main = function(){
		this.str = [];
	}
	this.main();
}

//時間回復用情報セットクラス
function repairTime(scene,randNum,fNum){
	this.setGauge = function(size){
		this.Gsize = size;
		var cls = this;
		var time = 10;
		if(!this.spUP){
			cls.change(1);
			var gauge = new setGauge(this.scene,260,this.Gsize,screenWidth - this.Gsize * 3,150,function(){
				cls.change(0);
				text.sp.tl.clear().unloop().
				fadeTo(0,time,eas).then(function(){
					this.parentNode.removeChild(this);
				});
			});
			//テキスト
			var gsp = gauge.Gsp;
			var text = new myText(this.scene,"イジケちゃう.EXE","myfont",this.Gsize / 2,gsp.x - gsp.width / 2,gsp.y + gsp.height);
			text.colors = ["rgba(255,255,0,1)","rgba(255,0,0,1)","rgba(0,255,0,1)"];
			var move = 30;
			text.sp.tl.
			moveBy(0,-move,time / 3,eas).
			moveBy(0,move,time / 3,eas).
			moveBy(0,-move,time / 3,eas).
			moveBy(0,move,time / 3,eas).
			delay(time * 2).
			loop();
			text.set();
		}
	}
	this.change = function(num){
		if(num != null) this.spUP = num;
		if(this.spUP){
			this.randNum = this.randNumClear * 2;
			this.fNum = this.fNumClear * 2;
		}else{
			this.randNum = this.randNumClear;
			this.fNum = this.fNumClear;
		}
	}
	this.main = function(){
		this.scene = scene;
		this.randNumClear = randNum;
		this.fNumClear = fNum;
		this.spUP = 0;
		this.change();
	}
	this.main();
}

//スタートアニメシーン
function startAnime(func){
	var scene = new Scene();
	game.pushScene(scene);
	//ready
	var ready = new myText(scene,"GetReady!!!!","myfont",120,"rgba(255,20,20,1)",10);
	var sp = ready.sp;
	sp.opacity = 0;
	sp.scale(0,0);
	ready.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
	var time = 10;
	sp.tl.
	fadeTo(1,time,eas).and().
	scaleTo(1,1,time,eas).
	delay(time).
	moveBy(screenWidth / 2,0,time,eas).and().
	fadeTo(0,time,eas).and().
	then(function(){
		tate2();
	});
	ready.set();
	sp.x = (screenWidth - sp.width) / 2;
	sp.y = (screenHeight - sp.height) / 2;
	//ひっつ
	function tate2(){
		//音声
		mySubSE.play(3);
		var w = 256; var h = 192;
		var num = 3; allFrame = 24;
		var sp = new Sprite(w,h);
		sp.x = (screenWidth - sp.width) / 2;
		sp.y = (screenHeight - sp.height) / 2;
		sp.scale(3,3);
		scene.addChild(sp);
		sp.image = game.assets[pics[num]];
		sp.tl.
		delay(3).
		then(function(){
			this.frame++;
			if(this.frame >= allFrame){
				this.parentNode.removeChild(this);
				//ぶち殺せ！
				var text = new myText(scene2D,"ヤク中のゴミ野郎を探してブチ殺せ!!!!!","myfont",65,"rgba(255,20,20,1)");
				var sp = text.sp;
				text.colors = ["rgba(255,0,0,1)","rgba(0,0,0,1)","rgba(255,255,255,1)"];
				text.set();
				sp.x = (screenWidth - sp.width) / 2;
				sp.y = -sp.height;
				var time = 5;
				sp.tl.
				moveBy(0,this.height,20,eas).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				scaleTo(0.9,0.9,time).scaleTo(1,1,time).
				moveBy(screenWidth,0,10,eas).and().
				fadeTo(0,20,eas).
				then(function(){
					this.parentNode.removeChild(this);
				});
				//シーン消去
				scene2DallClear(this.parentNode);
				func();
			}
		}).
		loop();
	}
}