//オプション画面セットクラス
function optionScene(size,x,y){
	//要素セット
	function setElement(num,type,name,setNum){
		this.type = type;
		this.num = num;
		this.name = name;
		this.setNum = setNum;
		//タイプ分け
		if(this.type == 0){
			this.max = 2;
		}else if(this.type == 1){
			this.max = 10;
		}
	}
	//要素追加処理
	this.push = function(num,type,name){
		this.elements.push(new setElement(num,type,name,this.elements.length));
	}
	//セーブ用配列生成
	this.setSaveString = function(){
		var str = [];
		for(var i=0; i<this.elements.length; i++){
			str[i] = this.elements[i].num;
		}
		return str;
	}
	//配列からロード
	this.setLoadString = function(str){
		for(var i=0; i<str.length; i++){
			this.elements[i].num = str[i];
		}
	}
	//単体surfセット
	this.setSFname = function(sf,txt){
		var ctx = sf.context;
		ctx.font = ""+this.size+"px myfont";
		var tWidth = ctx.measureText(txt).width;
		var bias = 1.1;
		sf.width = tWidth * bias;
		ctx.fillText(txt,(sf.width - tWidth) / 2,sf.height / 1.2);
	}
	//単体描画
	this.setSPname = function(x,y,txt){
		var sub = new myText(items.scene,"GO信者鏖殺プロジェクト","myfont",46,null,10);
		sub.sp.opacity = 0;
		sub.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
		sub.sp.tl.fadeTo(1,10,eas);
		sub.set();
		return sub.sp;
	}
	//描画全般
	this.show = function(){
		//シーンセット
		this.setScene();
		//背景描画
		this.setBack();
		//木彫SWK様
		this.setStepSP();
		//タイトル
		this.setTitle();
		//名前描画
		this.nameSPs = [];
		for(var i=0; i<this.elements.length; i++){
			this.nameSPs[i] = new myText(this.scene,this.elements[i].name,"myfont",this.size,null,10);
			var sub = this.nameSPs[i];
			sub.sp.opacity = 0;
			sub.colors = ["rgba(128,255,255,1)","rgba(50,128,128,1)","rgba(255,255,255,1)"];
			sub.sp.tl.fadeTo(1,10,eas);
			sub.set();
			sub.sp.x = this.x;
			sub.sp.y = this.y + i * this.inter;
		}
		//ステータス描画
		for(var i=0; i<this.elements.length; i++){
			//土台
			this.setStatesView(this.elements[i]);
			//ステータスカーソル
			this.setStatesPointer(this.elements[i]);
		}
		//ポインター描画
		this.setPointer();
	}
	//ステータスカーソル描画
	this.setStatesPointer = function(element){
		var setNum = element.setNum;
		var num = element.num;
		var nameClass = this.nameSPs[setNum];
		var nameSP = nameClass.sp;
		var sfW = nameSP.sfW;
		var sfH = nameSP.sfH;
		var sfInter = nameSP.inter;
		nameClass.curSP = new Sprite(sfW,sfH);
		var sp = nameClass.curSP;
		sp.x = this.startStaX + sfW * (num - 1) * sfInter;
		sp.y = nameSP.y;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		ctx.lineWidth = sf.height / 4;
		ctx.fillStyle = centerGrad(sf,"rgba(255,255,255,0.5)","rgba(0,0,0,0.5)");
		ctx.fillRect(0,0,sf.width,sf.height);
		ctx.strokeStyle = centerGrad(sf,"rgba(255,0,0,1)","rgba(255,255,255,1)");
		ctx.strokeRect(0,0,sf.width,sf.height);
		sp.image = sf;
		this.scene.addChild(sp);
	}
	//タイプ毎のステータス描画
	this.setStatesView = function(element){
		//変数セット
		var sp; var sf; var ctx; var self = this; var nameSP = this.nameSPs[element.setNum].sp;
		//分岐
		if(element.type == 0){
			var w = this.size * 2;
			var h = this.size;
			var inter = 2;
			var setW = element.max * w * inter;
			var setH = this.size;
			var texts = ["ON","OFF"];
			setSub(setW,setH);
			ctx.font = ""+this.size+"px myfont";
			ctx.lineWidth = this.size / 10;
			sp.x = this.startStaX;
			sp.y = nameSP.y;
			for(var i=0; i<element.max; i++){
				var setX = w * i * inter;
				var setY = 0;
				var gra = ctx.createLinearGradient(setX,setY,setX + w,setY + h);
				gra.addColorStop(0,"rgba(0,128,128,1)");
				gra.addColorStop(1,"rgba(0,255,255,1)");
				ctx.fillStyle = gra;
				ctx.fillRect(setX,setY,w,h);
				ctx.strokeStyle = "rgba(0,0,0,0.3)";
				ctx.strokeRect(setX,setY,w,h);
				var txt = texts[i];
				var tWidth = ctx.measureText(txt).width;
				ctx.fillStyle = "rgba(0,0,0,1)";
				ctx.fillText(txt,setX + (w - tWidth) / 2,h / 1.2,w);
			}
		}else
		if(element.type == 1){
			var w = this.size / 2;
			var h = this.size;
			var inter = 1.8;
			var setW = element.max * w * inter;
			var setH = this.size;
			setSub(setW,setH);
			ctx.lineWidth = this.size / 10;
			sp.x = this.startStaX;
			sp.y = nameSP.y;
			for(var i=0; i<element.max; i++){
				var setX = w * i * inter;
				var setY = 0;
				var gra = ctx.createLinearGradient(setX,setY,setX + w,setY + h);
				gra.addColorStop(0,"rgba(0,128,0,1)");
				gra.addColorStop(1,"rgba(0,255,0,1)");
				ctx.fillStyle = gra;
				ctx.fillRect(setX,setY,w,h);
				ctx.strokeStyle = "rgba(0,0,0,0.3)";
				ctx.strokeRect(setX,setY,w,h);
			}
		}
		sp.image = sf;
		//1ステータスの長さセット
		nameSP.sfW = w;
		nameSP.sfH = h;
		nameSP.inter = inter;
		//汎用セット
		function setSub(w,h){
			element.sp = new Sprite(w,h);
			sp = element.sp;
			sp.sf = new Surface(sp.width,sp.height);
			sf = sp.sf;
			ctx = sf.context;
			self.scene.addChild(sp);
		}
	}
	//ポインタ描画
	this.setPointer = function(){
		var width = 20;
		this.pointer = new Sprite(width,width);
		var sp = this.pointer;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		var white = 2;
		ctx.lineWidth = white;
		ctx.strokeStyle = "rgba(255,255,255,1)";
		ctx.fillStyle = "rgba(255,0,0,1)";
		ctx.arc(sf.width / 2,sf.height / 2,sf.width / 2 - white,0,360,false);
		ctx.fill();
		ctx.stroke();
		sp.image = sf;
		this.scene.addChild(sp);
		var self = this;
		//xyセット
		sp.setXY = function(){
			this.mx = self.x - self.size;
			this.my = self.y + self.inter * (self.point - 1) + (self.size - this.height) / 2;
		}
		//ポイント判定
		sp.max = this.elements.length;
		sp.min = 1;
		sp.pointChange = function(num){
			var next = self.point + num;
			if(next > this.max){
				self.point = this.min;
			}else if(next < this.min){
				self.point = this.max;
			}else{
				self.point = next;
			}
		}
		//移動
		sp.move = function(){
			//アニメ
			this.moving = 1;
			this.tl.
			moveTo(this.mx,this.my,this.time,eas).
			then(function(){
				this.moving = 0;
			});
		}
		//移動まとめ
		sp.moveSet = function(num){
			//音声
			mySWKSE.play(6);
			//
			this.pointChange(num);
			this.setXY();
			this.move();
		}
		sp.setXY();
		sp.x = sp.mx;
		sp.y = sp.my;
		//ステータスカーソル移動処理
		sp.moveStaCursor = function(num,x,y){
			var point = self.point;
			var nameClass = self.nameSPs[point - 1];
			var nameSP = nameClass.sp;
			var curSP = nameClass.curSP;
			var sfW = nameSP.sfW;
			var inter = nameSP.inter;
			var time = 3;
			var element = self.elements[point - 1];
			var next = element.num + num;
			if(next > element.max){
				element.num = 1;
			}else if(next < 1){
				element.num = element.max;
			}else{
				element.num = next;
			}
			var mx = self.startStaX + sfW * (element.num - 1) * inter;
			var my = curSP.y;
			this.moving = 1;
			var cls = sp;
			curSP.tl.
			moveTo(mx,my,time,eas).
			then(function(){
				cls.moving = 0;
			});
			//移動毎の処理
			self.setMovingCommand();
			//音声
			mySWKSE.play(6);
			//
		}
		//毎フレーム処理
		sp.moving = 0;
		sp.time = 3;
		sp.addEventListener("enterframe",function(){
			if(this.moving == 0){
				if(game.input.down){
					this.moveSet(1);
				}else
				if(game.input.up){
					this.moveSet(-1);
				}else
				if(game.input.right){
					this.moveStaCursor(1,this.x,this.y);
				}else
				if(game.input.left){
					this.moveStaCursor(-1,this.x,this.y);
				}else
				if(game.input.z){
					//音声
					mySWKSE.play(6);
					scene2DallClear();
					title();
					//セーブ
					var str = self.setSaveString();
					localStorage.setItem("option",JSON.stringify(str));
				}
			}
		});
	}
	//木彫SWK様
	this.setStepSP = function(){
		var allFrame = 4;
		var img = game.assets[pics[11]];
		this.stepSP = new Sprite(120,200);
		var sp = this.stepSP;
		sp.image = img;
		sp.x = rand(screenWidth - sp.width);
		sp.y = rand(screenHeight - sp.height);
		sp.opacity = 0;
		sp.count = 0;
		sp.tl.
		fadeTo(1,10).
		then(function(){
			this.addEventListener("enterframe",function(){
				this.frame+=0.2;
				this.count++;
				if(this.frame >= allFrame){
					this.frame = 0;
				}
				if(this.count == 50){
					this.count = 0;
					this.x = rand(screenWidth - this.width);
					this.y = rand(screenHeight - this.height);
				}
			});
		});
		this.scene.addChild(sp);
	}
	//移動毎に行われる処理
	this.setMovingCommand = function(){
		//BGM再生
		myBGM.play(this.scene,this.BGMid);
	}
	//タイトルセット
	this.setTitle = function(){
		var sub = new myText(this.scene,"オプション","myfont",90,null,null);
		sub.sp.opacity = 0;
		sub.colors = ["rgba(255,0,255,1)","rgba(128,0,128,1)","rgba(255,255,255,1)"];
		sub.sp.tl.
		fadeTo(1,10,eas).
		then(function(){
			this.tl.
			scaleTo(0.8,0.8,10,eas).
			scaleTo(1,1,10,eas).
			loop();
		});
		sub.sp.x = (screenWidth - sub.sp.width) / 2;
		sub.sp.y = 20;
		sub.set();
	}
	//背景セット
	this.setBack = function(){
		this.back = new Sprite(screenWidth,screenHeight);
		var sp = this.back;
		sp.opacity = 0.5;
		sp.image = game.assets[pics[8]];
		this.scene.addChild(sp);
	}
	//シーンセット
	this.setScene = function(){
		this.scene = new Scene();
		game.pushScene(this.scene);
		//BGM再生
		this.setMovingCommand();
	}
	//メイン
	this.main = function(){
		this.elements = [];
		this.size = size;
		this.inter = this.size * 1.5;
		this.x = x;
		this.y = y;
		this.startStaX =  screenWidth / 2;
		this.point = 1;
		this.BGMid = 4;
	}
	this.main();
}