//ランキング生成、描画用クラス
function makeRankings(rankClear){
	//単ランキングクラス
	function ranking(lengX,lengY,all,ele,rankClear){
		//情報格納クラス
		function info(rank,ele){
			this.str = [];
			for(var i=0; i<ele; i++){
				this.str[i] = "null";
			}
			this.rank = rank;
		}
		//情報格納クラス追加処理
		this.set = function(ele){
			this.infos.push(new info(this.infos.length + 1,ele));
		}
		//初期化
		this.clear = function(){
			for(var i=0; i<this.all; i++){
				this.set(this.ele);
			}
			//保留
			/*
			//初期化情報がある場合はそちらを突っ込む
			if(this.rankClear != null){
				for(var i=0; i<this.all; i++){
					this.infos[i].str = this.rankClear.str;
				}
			}
			*/
		}
		//メイン
		this.main = function(){
			this.infos = [];
			this.lengX = lengX;
			this.lengY = lengY;
			if(all == null) this.all = 10;
			if(ele == null) this.ele = 3;
			this.rankClear = rankClear;
			this.clear();
		}
		this.main();
	}
	//配列値へとまとめた物を返す(セーブ用)
	this.setSaveString = function(){
		var str = [];
		for(var i=0; i<this.rankings.length; i++){
			str[i] = [];
			for(var j=0; j<this.rankings[i].infos.length; j++){
				if(this.rankings[i].infos[j].str[0] == "null") break;
				str[i][j] = this.rankings[i].infos[j].str;
			}
		}
		return str;
	}
	//配列値からデータを読み込む(ロード用)
	this.setLoadString = function(str){
		for(var i=0; i<str.length; i++){
			for(var j=0; j<str[i].length; j++){
				var sets = str[i][j];
				this.insertAuto(i,sets[0],sets[1],sets[2]);
			}
		}
		//最終挿入場所の初期化
		this.setLastChangeElement(null,null);
	}
	//最後に挿入した場所を記録
	this.setLastChangeElement = function(rankNum,eleNum){
		this.lastChange = Array(rankNum,eleNum);
	}
	//自動挿入(内容値で判断)
	this.insertAuto = function(){
		//引数を配列に格納
		var arg = [];
		for(var i=0; i<arguments.length; i++){
			arg[i] = arguments[i];
		}
		//引数1は単ランキング指定
		var rankNum = arg[0];
		arg.splice(0,1);
		//挿入できる場所の探索[eleNum].str
		var setTotal = arg[0];					//挿入したいトータル値
		var str = this.rankings[rankNum].infos;
		var eleNum = null;
		for(var i=0; i<str.length; i++){
			if(setTotal >= str[i].str[0] || str[i].str[0] == "null"){
				eleNum = i;
				break;
			}
		}
		//挿入処理
		if(eleNum != null) this.insert(rankNum,eleNum,arg);
	}
	//ランキングクラス挿入処理
	this.insert = function(){
		//引数を配列に格納
		var arg = [];
		for(var i=0; i<arguments.length; i++){
			arg[i] = arguments[i];
		}
		//引数2までは配列指定用
		var rankNum = arg[0];
		var eleNum = arg[1];
		var str = arg[2];
		//指定配列への格納
		var ranking = this.rankings[rankNum];
		var info = ranking.infos[eleNum];
		var length = 0;
		for(var i=0; i<ranking.all; i++){
			if(ranking.infos[i].str[0] == "null") break;
			length++;
		}
		for(var i=ranking.all-1; i>eleNum; i--){
			ranking.infos[i].str = ranking.infos[i-1].str
		}
		ranking.infos[eleNum].str = str;
		//挿入場所記憶
		this.setLastChangeElement(rankNum,eleNum);
	}
	//ランキングクラス追加処理
	this.push = function(lengX,lengY){
		this.rankings.push(new ranking(lengX,lengY,null,null,rankClear));
	}
	//メイン
	this.main = function(){
		this.rankings = [];
		this.setLastChangeElement();			//最終追加要素情報初期化
	}
	this.main();
}

//ランキング描画クラス
function showRanking(size,width,inter,rankData,lastFunc){
	//時間変換
	this.setTime = function(time){
		var min = Math.floor(time / 60 / 60);
		var sec = Math.floor(time / 60 % 60);
		var msec = Math.floor(time % 60 * 100 / 60);
		return ""+min+":"+(("0" + sec).slice(-2))+"."+(("0" + msec).slice(-2))+"";
	}
	//単surfセット
	this.setRankSF = function(info,types,colors){
		var all = info.str.length;
		var allW = info.sf.width / all;
		var w = (info.sf.width - this.rankW) / all;
		var h = info.sf.height;
		var yBias = 1.2;
		var sf = info.sf;
		var ctx = sf.context;
		ctx.font = ""+this.size / 1.5+"px myfont";
		ctx.lineWidth = this.size / 10;
		var rank = ""+info.rank+"";
		var tWidth = ctx.measureText(rank).width;
		ctx.strokeStyle = "rgba(0,0,0,1)";
		ctx.strokeText(rank,(this.rankW - tWidth) / 2,h / yBias,this.rankW);
		ctx.fillStyle = "rgba(255,255,0,1)";
		ctx.fillText(rank,(this.rankW - tWidth) / 2,h / yBias,this.rankW);
		for(var i=0; i<all; i++){
			var x = i * w + this.rankW;
			var y = 0;
			var txt;
			if(types[i] == 0){
				txt = ""+info.str[i]+"";
			}else if(types[i] == 1){
				txt = this.setTime(info.str[i]);
			}
			var tWidth = ctx.measureText(txt).width;
			if(tWidth > w) tWidth = w;
			ctx.fillStyle = centerGrad(sf,"rgba(0,255,0,0.6)","rgba(0,100,0,0.6)");
			ctx.fillRect(x,y,w,h);
			ctx.strokeStyle = "rgba(0,0,0,0.5)";
			ctx.strokeRect(x,y,w,h);
			ctx.strokeStyle = "rgba(255,255,255,1)";
			ctx.strokeText(txt,x + (w - tWidth) / 2,h / yBias,w);
			ctx.fillStyle = colors[i];
			ctx.fillText(txt,x + (w - tWidth) / 2,h / yBias,w);
		}
	}
	//スプライトアニメ添加
	this.setAnime = function(sp,delay){
		var time = 10;
		var move = screenWidth / 4;
		sp.tl.
		moveBy(move,0,0).
		delay(delay).
		moveBy(-move,0,time,eas).and().
		fadeTo(1,time,eas).and().
		scaleTo(1,1,time,eas);
	}
	//単スプライトセット
	this.setSP = function(info,x,y,types,colors){
		info.sp = new Sprite(this.width,this.size);
		info.sp.x = x;
		info.sp.y = y;
		info.sp.opacity = 0;
		info.sp.scale(3,3);
		info.sf = new Surface(info.sp.width,info.sp.height);
		this.setRankSF(info,types,colors);
		info.sp.image = info.sf;
		this.scene.addChild(info.sp);
		return info.sp;
	}
	//項目名セット
	this.setItemName = function(name,color,x,y,w,h){
		var sp = new Sprite(w,h);
		sp.x = x;
		sp.y = y;
		var sf = new Surface(sp.width,sp.height);
		setItemNameSurf(name,sf);
		sp.image = sf;
		sp.opacity = 0;
		sp.scale(0,2);
		this.scene.addChild(sp);
		return sp;
		
		function setItemNameSurf(){
			var ctx = sf.context;
			ctx.font = ""+h / 1.4+"px myfont";
			var tWidth = ctx.measureText(name).width;
			ctx.lineWidth = h / 10;
			ctx.strokeStyle = "rgba(0,0,0,0.3)";
			ctx.strokeText(name,(w - tWidth) / 2 + 5,h,w);
			ctx.fillStyle = color;
			ctx.fillText(name,(w - tWidth) / 2,h,w);
		}
	}
	//単ランキング名セット
	this.setRankingName = function(name,x,y){
		var sp = new Sprite(this.size * 5,this.size);
		sp.x = x + sp.width / 2 + this.rankW / 2;
		sp.y = y;
		sp.sf = new Surface(sp.width,sp.height);
		sp.opacity = 0;
		var sf = sp.sf;
		var ctx = sf.context;
		ctx.font = ""+sf.height+"px myfont";
		ctx.lineWidth = this.size / 10;
		var tWidth = ctx.measureText(name).width;
		ctx.strokeStyle = "rgba(0,50,0,1)";
		ctx.strokeText(name,(sf.width - tWidth) / 2,sf.height / 1.2);
		ctx.fillStyle = centerGrad(sf,"rgba(128,128,0,1)","rgba(255,255,255,1)");
		ctx.fillText(name,(sf.width - tWidth) / 2,sf.height / 1.2);
		sp.image = sf;
		this.scene.addChild(sp);
		var time = 30;
		var move = 100;
		sp.tl.
		moveBy(0,-move,0).
		moveBy(0,move,time,eas).and().
		fadeTo(1,time,eas);
	}
	//単ランキングセット
	this.showOne = function(num,x,y){
		var str = this.data.rankings[num].infos;
		var rankClear = this.data.rankings[num].rankClear;
		//ランキング名セット
		var ranking = this.data.rankings[num];
		var rankingName = ""+ranking.lengX+" x "+ranking.lengY+"";
		var setx = this.width * num;
		var sety = y - this.size * 2;
		this.setRankingName(rankingName,setx,sety);
		//項目名セット
		var rankNames = rankClear.names;
		var rankNameColors = rankClear.nameColors;
		for(var i=0; i<rankNames.length; i++){
			var setw = this.width / rankNames.length;
			var seth = this.size;
			var oneWidth = (this.width - this.rankW) / rankNames.length;
			var setx = this.rankW + x + i * oneWidth;
			var sety = y - seth * 1.2;
			var sp = this.setItemName(rankNames[i],rankNameColors[i],setx,sety,setw,seth);
			var time = 8;
			sp.tl.
			delay(time * i).
			scaleTo(1,1,time,eas).and().
			fadeTo(1,time,eas);
		}
		//ランキング描画
		var rankTypes = rankClear.types;
		var rankColors = rankClear.colors;
		var time = 3;
		for(var i=0; i<str.length; i++){
			if(str[i].str[0] != "null"){
				var setx = x;
				var sety = y + (i * this.size * this.inter);
				var sp = this.setSP(str[i],setx,sety,rankTypes,rankColors);
				this.setAnime(sp,i * time);
			}
		}
	}
	//セットしたデータを元に描画
	this.show = function(){
		//背景描画
		this.setBack();
		//タイトル描画
		this.setTitle();
		//ランキング描画
		var ranks = this.data.rankings;
		for(var i=0; i<ranks.length; i++){
			var setx = this.x + (this.width * this.inter * i);
			var sety = this.y;
			this.showOne(i,setx,sety);
		}
		//空entでウェイト
		var ent = new Entity();
		this.scene.addChild(ent);
		var time = 40;
		var self = this;
		ent.tl.
		delay(time).
		then(function(){
			//最後に描画した場所を囲む
			self.setCircleLastChange();
			//入力待ち
			this.addEventListener("enterframe",function(){
				if(game.input.z){
					//音声
					mySWKSE.play(6);
					//シーン消去
					scene2DallClear(this.parentNode);
					self.lastFunc();
				}
			});
		});
	}
	//最後に描画した場所の情報がある場合の強調処理
	this.setCircleLastChange = function(){
		var ranks = this.data;
		var rankNum = ranks.lastChange[0];
		var eleNum = ranks.lastChange[1];
		if(rankNum != null && eleNum != null){
			//初期化
			ranks.lastChange[0] = null;
			ranks.lastChange[1] = null;
			//アニメーションセット
			var time = 20;
			var sp = this.data.rankings[rankNum].infos[eleNum].sp;
			sp.tl.
			scaleTo(0.9,0.9,time,eas).
			scaleTo(1.1,1.1,time,eas).
			loop();
		}
	}
	//背景セット
	this.setBack = function(){
		this.backSP = new Sprite(screenWidth,screenHeight);
		var sp = this.backSP;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		ctx.fillStyle = "rgba(255,255,255,1)";
		ctx.fillRect(0,0,sf.width,sf.height);
		makeSNTwindowSF(sf,this.size);
		sp.image = sf;
		this.scene.addChild(sp);
	}
	//タイトルセット
	this.setTitle = function(){
		var size = this.size * 3;
		this.titleSP = new Sprite(screenWidth,size);
		var sp = this.titleSP;
		sp.sf = new Surface(sp.width,sp.height);
		var sf = sp.sf;
		var ctx = sf.context;
		var txt = "ランキングだわっ☆";
		ctx.font = ""+size+"px myfont";
		var tWidth = ctx.measureText(txt).width;
		sf.width = tWidth * 1.1;
		sp.width = sf.width;
		ctx.lineWidth = size / 10;
		ctx.strokeStyle = centerGrad(sf,"rgba(50,0,0,1)","rgba(128,0,0,1)");
		ctx.strokeText(txt,(sf.width - tWidth) / 2,sf.height / 1.1,sf.width);
		ctx.fillStyle = centerGrad(sf,"rgba(255,255,255,1)","rgba(255,255,0,1)");
		ctx.fillText(txt,(sf.width - tWidth) / 2,sf.height / 1.1,sf.width);
		sp.image = sf;
		this.scene.addChild(sp);
		sp.x = (screenWidth - sp.width) / 2;
		sp.y = screenHeight / 50;
		var time = 20;
		var move = 30;
		sp.tl.
		moveBy(0,-move,time / 4,eas).moveBy(0,move,time / 4,eas).
		moveBy(0,-move,time / 4,eas).moveBy(0,move,time / 4,eas).
		delay(time).
		loop();
	}
	//シーン生成
	this.setScene = function(){
		this.scene = new Scene();
		game.pushScene(this.scene);
		//BGM再生
		myBGM.play(this.scene,1);
	}
	//全長計算
	this.setAllLong = function(){
		var ranings = this.data.rankings;
		this.allWidth = Math.floor(this.width * this.inter * ranings.length - this.width * (this.inter - 1));
		this.allHeight = Math.floor(this.size * this.inter * ranings[0].all);
	}
	//xyセット
	this.setXY = function(x,y){
		this.setAllLong();
		if(x == null){
			this.x = (screenWidth - this.allWidth) / 2;
		}else{
			this.x = x;
		}
		if(y == null){
			this.y = screenHeight - this.allHeight * 1.1;
		}else{
			this.y = y;
		}
	}
	//セット処理まとめ
	this.set = function(){
		this.setScene();				//シーンセット
		this.setXY();					//全体XYセット
		this.show();					//描画
	}
	//メイン
	this.main = function(){
		this.size = size;
		this.width = width;
		this.rankW = this.width / 10;
		this.inter = inter;
		this.data = rankData;
		this.lastFunc = lastFunc;
	}
	this.main();
}

//ランキング初期化情報クラス
function rankingFirstInfo(){
	this.setSub = function(arg){
		var str = [];
		for(var i=0; i<arg.length; i++){
			str.push(arg[i]);
		}
		return str;
	}
	this.setStrColor = function(){
		this.colors = this.setSub(arguments);
	}
	this.setName = function(){
		this.names = this.setSub(arguments);
	}
	this.setNameColor = function(){
		this.nameColors = this.setSub(arguments);
	}
	this.setType = function(){
		this.types = this.setSub(arguments);
	}
	this.main = function(){
		this.str = this.setSub(arguments[0]);
	}
	this.main(arguments);
}